tableHeight = 80
rowShift = 40
maxRowHeight_landscape = tableHeight + 4 * rowShift
maxRowHeight_portrait = tableHeight + tableHeight + 3 * rowShift
EMapMode = {Mode_3D = 1, Mode_2D = 2, Mode_2D_NU = 3}
wGetNUSupported = EMapMode.Mode_2D_NU == 3 and sc_GetSysEntry("map", "north_up", 0)

sc_start_customize = function()
	sc_gjSPfix_tolerance_change()
    -- trip comp
    if MODEL.lua.vgjTripCompDataSave() then
		sc_gjTripLoad()
    end	
	-- short menu
	sc_wBuildCockpitMenu()
	ui.fullCockpitMenuList:sort("menu_index")

	-- gesture 
	sc_gj_gesture()	
end
 
sc_set_MAPresolution()

-- gesture -------------------------------------------

sc_gj_gesture = function()
 if MODEL.lua.vgjGestureOn() then
   GESTURE("AC2", sc_gjGest1)
   GESTURE("CA6", sc_gjGest2)
   GESTURE("GI2", sc_gjGest3)
   GESTURE("IG6", sc_gjGest4)
   GESTURE("DF2", sc_gjGest5)
   GESTURE("FD6", sc_gjGest6)
   GESTURE("BH0", sc_gjGest7)
   GESTURE("HB4", sc_gjGest8)
   GESTURE("AG0", sc_GestViewpoint)
   GESTURE("GA4", sc_GestColorMode)
   GESTURE("IC4", sc_GestCapScreen)
   GESTURE("CI0", sc_GestCapScreen)
   GESTURE("AI1", sc_gjGestExit)
   GESTURE("CG7", sc_gjGestExit)
   GESTURE("IA5", sc_gjGestExit)
   GESTURE("GC3", sc_gjGestExit)
 else
   GESTURE("AC2")
   GESTURE("CA6")
   GESTURE("GI2")
   GESTURE("IG6")
   GESTURE("DF2")
   GESTURE("FD6")
   GESTURE("HB4")
   GESTURE("BH0")
   GESTURE("AG0")
   GESTURE("CI0")
   GESTURE("GA4")
   GESTURE("IC4")
   GESTURE("AI1")
   GESTURE("CG7")
   GESTURE("IA5")
   GESTURE("GC3")
 end
end

sc_gjGest1 = function()
	sc_gjGest_bSel(0)
end
sc_gjGest2 = function()
	sc_gjGest_bSel(1)
end
sc_gjGest3 = function()
	sc_gjGest_bSel(2)
end
sc_gjGest4 = function()
	sc_gjGest_bSel(3)
end
sc_gjGest5 = function()
	sc_gjGest_bSel(4)
end
sc_gjGest6 = function()
	sc_gjGest_bSel(5)
end
sc_gjGest7 = function()
	sc_gjGest_bSel(6)
end
sc_gjGest8 = function()
	sc_gjGest_bSel(7)
end

sc_gjGest_bSel = function(butt)
	if vActiveState() == "st_easynav" then
		PLAYSOUND("!success")
		sc_gjOpenCockpitMenuItem(butt)
		if MODEL.lua.dragMode() then
			sc_backFromdragmode()
		end
	end	
end

sc_gjGestExit = function()
	PLAYSOUND("!success")
	sc_DoExit()
end

sc_GestCapScreen = function(force)
    MODEL.ui.__screenshot()
    doDelayed(15, function()
      sc_InfoMessageBox(m_i18n("DEBUG~Screen Captured"), true)
    end
    )
end

sc_GestViewpoint = function()
  if vActiveState() == "st_easynav" then
	if MODEL.lua.vEasyViewMode() < MapSettingsViewModes.max then 
        MODEL.lua.vEasyViewMode = MODEL.lua.vEasyViewMode() + 1
	else 
        MODEL.lua.vEasyViewMode = 0
	end
	
    PLAYSOUND("!success")
    if MODEL.lua.vEasyViewMode() == 2 then
	   sc_gjShowHelpText(m_i18n("High"), "ico_infofieldswitch_noroute_sml.bmp#3")
    elseif MODEL.lua.vEasyViewMode() == 1 then
	   sc_gjShowHelpText(m_i18n("Normal"), "ico_infofieldswitch_noroute_sml.bmp#3")
    elseif MODEL.lua.vEasyViewMode() == 0 then
	   sc_gjShowHelpText(m_i18n("Low"), "ico_infofieldswitch_noroute_sml.bmp#3")
    end       
   sc_Set_Presets()
  end  
end

sc_GestColorMode = function()
  if vActiveState() == "st_easynav" then
	if MODEL.lua.vEasyColorMode() < MapSettingsDayNight.max then 
        MODEL.lua.vEasyColorMode = MODEL.lua.vEasyColorMode() + 1
	else 
        MODEL.lua.vEasyColorMode = 0
	end
	
    PLAYSOUND("!success")
    if MODEL.lua.vEasyColorMode() == 0 then
	   sc_gjShowHelpText(m_i18n("Day"), "ico_MapColorsDay_sml.bmp#3")
    elseif MODEL.lua.vEasyColorMode() == 1 then
	   sc_gjShowHelpText(m_i18n("Night"), "ico_MapColorsNight_sml.bmp#3")
    elseif MODEL.lua.vEasyColorMode() == 2 then
	   sc_gjShowHelpText(m_i18n("Auto"), "ico_MapColorsAuto_sml.bmp#3")
    end       
   sc_Set_DayNightMode()
  end  
end

--gj skin day night --------------------------------------------------
sc_change_day_night = function()
	MODEL.lua.vgjDayNightTrigger = false
	MODEL.lua.vgjDayNightTrigger = true
end

sc_gjTunnelOn = function()
	sc_TunnelOn()
	sc_change_day_night()
end

sc_gjTunnelOff = function()
	sc_TunnelOff()
	sc_change_day_night()
end

sc_SetTheme_orig = sc_SetTheme
sc_SetTheme = function()
  LOGPRINT("Change Colour")
  local themeList = MODEL.screen.theme.list
  MODEL.screen.theme.change_theme(themeList[themeList.index()].filename(), isItNightTheme)
  sc_change_day_night()
end


-- speedcam ---------------------------------------------------------------------------------
vgj_spc_cat_name = "" 
gjSpSoundName = ""
 
-- first play speedcam 
sc_gjfirstplayspeedcam = function()
	local spc_cat = MODEL.navigation.curr_speedcam.category()
	local spc_speed = MODEL.navigation.curr_speedcam.speed_limit()
--test	local spc_cat = 0
--test	local spc_speed = 50
	
	vgj_spc_cat_name = "speedcam_category:" .. spc_cat
		
	gjSpSoundName = sc_GetSysEntry(vgj_spc_cat_name, "skin_first_sound", L"")	
    if gjSpSoundName ~= L"" then
		sc_gjspeedcam_playsound(gjSpSoundName)
    end	
	
	local gjSpeedSound = var.new()
	gjSpeedSound = sc_GetSysEntry(vgj_spc_cat_name, "skin_speed_sound_delay", 0)
    if gjSpeedSound > 0 then
		killDelayed(gjDel1)
		gjDel1 = doDelayed(gjSpeedSound, function()
			sc_gjspeedcam_playsound(spc_speed)
		end
		) 	
    end	

	MODEL.lua.gjSpRepDist = sc_GetSysEntry(vgj_spc_cat_name, "skin_repeat_distance", 0)
    if MODEL.lua.gjSpRepDist() > 0 then
		gjm_spcrep:START("NO_TRIGGER")
	end
	
end

-- repeat play speedcam
sc_gjrepeatplayspeedcam = function()
	gjm_spcrep:STOP()
	gjSpSoundName = sc_GetSysEntry(vgj_spc_cat_name, "skin_repeat_sound", L"")
    if gjSpSoundName ~= L"" then
		sc_gjspeedcam_playsound(gjSpSoundName)
    end	
end

-- play off speedcam
sc_gj_spcoff = function()
	gjSpSoundName = sc_GetSysEntry(vgj_spc_cat_name, "skin_off_sound", L"")
    if gjSpSoundName ~= L"" then
		sc_gjspeedcam_playsound(gjSpSoundName)
    end		
end    

--play sounds
sc_gjspeedcam_playsound = function(snd_nm)		
	if snd_nm == L"" then
		return
	end	
	local spc_audio_path = var.new()
	spc_audio_path = sc_GetSysEntry("warning", "skin_audio_path", L"")		
	if spc_audio_path ~= L"" then
		snd_nm = spc_audio_path .. L"/" .. snd_nm
	end
	MODEL.sound.playchanneltest("alarmeffect", snd_nm)	
end 

-- speedcam edit

sc_gjEditSpeedcam = function()
  gEditSpeedcamFromInfo = false
  sc_CopySpeedCamUserList()
  MODEL.lua.managespeedcam = true
  if #MODEL.map.primary.clicked_speedcam_list == 1 then
    sc_UpdateSpeedcamModels(MODEL.map.primary.clicked_speedcam_list[0])
    sc_NextStateAnim(st_EditSpeedcam, "fade", 1, "")
  else
    sc_NextStateAnim(st_SelectSpeedcam, "fade", 1, "")
  end
end

sc_gjAddSpeedcam = function()
  MODEL.lua.managespeedcam = false
  sc_UpdateSpeedcamModels()
  sc_NextStateAnim(st_EditSpeedcam, "fade", 1, "")
end


-- speedcam test ---------------------------------------------------------------------------------
 
sc_gjspeedcamtest = function()
	local spc_cat = MODEL.INT.ui.extendedSpeedCamList.current.id()
	local spc_speed = 50

	vgj_spc_cat_name = "speedcam_category:" .. spc_cat
		
	gjSpSoundName = sc_GetSysEntry(vgj_spc_cat_name, "skin_first_sound", L"")	
    if gjSpSoundName ~= L"" then
		sc_gjspeedcam_playsound(gjSpSoundName)
    end	
	local gjSpeedSound = var.new()
	gjSpeedSound = sc_GetSysEntry(vgj_spc_cat_name, "skin_speed_sound_delay", 0)
   if gjSpeedSound > 0 then
		killDelayed(gjDel1)
		gjDel1 = doDelayed(gjSpeedSound, function()
			sc_gjspeedcam_playsound(spc_speed)
		end
		) 	
    end	
end

-- near speed limit ----------------------------------------------------------------

gjNearSpeed = 0 

sc_gj_Overspeed_on = function()
    if gjNearSpeed == 1 then
		return
	end

	if MODEL.lua.vgjOSpeedEnable() then
		killDelayed(gjOS1)
		killDelayed(gjOS2)
		gjOS1 = doDelayed(70, function()
			if MODEL.navigation.car.current_speed() > 5 then
				gjNearSpeed = 1
				PLAYSOUND("alarmeffect", "ovspon")
			end	
		end
		)
		
		
		if MODEL.lua.vgjOSpeedReTime() > 0 then
			killDelayed(gjOS3)
			sc_gj_Overspeed_repeat()
		end
				
	end

	
end

sc_gj_Overspeed_repeat = function()
	if MODEL.warning.driveralert.speed_limit() > MODEL.navigation.car.current_speed() then
		killDelayed(gjOS3)
		return
	end
	
	gjOS3 = doDelayed(MODEL.lua.vgjOSpeedReTime(), function()
		if MODEL.navigation.car.current_speed() > 5 then
			PLAYSOUND("alarmeffect", "ovspon")
			sc_gj_Overspeed_repeat()
		end	
	end
	)		
end

sc_gj_Overspeed_off = function()
    if gjNearSpeed == 0 then
		return
	end

	if MODEL.lua.vgjOSpeedEnable() then
		killDelayed(gjOS1)
		killDelayed(gjOS2)
		killDelayed(gjOS3)
		gjOS2 = doDelayed(70, function()
			if MODEL.navigation.car.current_speed() > 5 then
				gjNearSpeed = 0
				PLAYSOUND("alarmeffect", "ovspoff")
			end	
		end
		)
	end

end 

-- voice speed limit ---------------------------------------------------------------------------------

sc_gj_splchange = function()
	local speed_lim = MODEL.warning.driveralert.speed_limit()	
	if MODEL.lua.gjSpVoiceEnable() then
		killDelayed(gjDel2)
		gjDel2 = doDelayed(150, function()
			sc_gjspeedcam_playsound(speed_lim)
		end
		) 
	end
end

sc_gj_splimSelect = function()
  PLAYSOUND( "!button" )
  MODEL.lua.gjSpVoiceEnable = not MODEL.lua.gjSpVoiceEnable()
  MODEL.lua.gjPosIcon = 0
  if MODEL.lua.gjSpVoiceEnable() then
	sc_gj_splchange()
	sc_gjShowHelpText(m_i18n("Speed limit voice ON"), "ico_done_sml.bmp#3")
  else
	sc_gjShowHelpText(m_i18n("Speed limit voice OFF"), "ico_cancel_mid.bmp#3")
  end
end

-- speed tolerance ---------------------------------------------

sc_gjSPfix_tolerance_change = function()
	if MODEL.warning.speedwarn_alt_toltype() then
		MODEL.warning.speedwarn_alt_tolerance = MODEL.lua.vgjspeed_in_city()
		MODEL.warning.speedwarn_tolerance = MODEL.lua.vgjspeed_out_of_city()
	else
		MODEL.warning.speedwarn_alt_tolerance = MODEL.lua.vgjspeed_in_city()+100
		MODEL.warning.speedwarn_tolerance = MODEL.lua.vgjspeed_out_of_city()+100
	end
	MODEL.warning.speedwarn_toltype = MODEL.warning.speedwarn_alt_toltype()
end


st_SpeedWarningSettings.exit = function()
	sc_gjSPfix_tolerance_change()
end


sc_GetAdvancedSpeedLimitPhase_orig = sc_GetAdvancedSpeedLimitPhase
sc_GetAdvancedSpeedLimitPhase = function(speed, speed_limit)
	if MODEL.navigation.car.is_incity() then
		if MODEL.warning.speedwarn_alt_toltype() then 
			if speed <= speed_limit then
				return 0
			elseif speed <= speed_limit + MODEL.warning.speedwarn_alt_tolerance() then
				return 1
			else
				return 2
			end	
		else
			if speed <= speed_limit then
				return 0
			elseif speed <= speed_limit * MODEL.warning.speedwarn_alt_tolerance() / 100 then
				return 1
			else
				return 2
			end	
		end
	else	
		if MODEL.warning.speedwarn_alt_toltype() then 
			if speed <= speed_limit then
				return 0
			elseif speed <= speed_limit + MODEL.warning.speedwarn_tolerance() then
				return 1
			else
				return 2
			end	
		else
			if speed <= speed_limit then
				return 0
			elseif speed <= speed_limit * MODEL.warning.speedwarn_tolerance() / 100 then
				return 1
			else
				return 2
			end	
		end
  end
end


-- position ---------------------------------------------------------------------------------

createState("st_gjUserPosition")
st_gjUserPosition:useLayers(backgroundLayers, ui_gjUserPosition)
st_gjUserPosition.init = function()
	txtTitle:SET(m_i18n("Select position"))
end

sc_gj_open_ListPosition = function()
	sc_NextStateAnim(st_gjUserPosition, "horz_scroll", 1, "")
end

sc_gjUserPositionAdd_OnRelease_OK = function(PosType)
    local gcoor = MODEL.navigation.car.position()
	local gcountry = MODEL.navigation.car.address.loccountrylong()
	local gcity = MODEL.navigation.car.address.city()
	local gstreet = MODEL.navigation.car.address.street()
	local SpeedLimit = MODEL.warning.driveralert.speed_limit()
	local CurrentSpeed = MODEL.navigation.car.current_speed()
	local glat = Format_GeoCoord(gcoor,EGeoCoordDisplayMode.Latitude_Only)
	local glong = Format_GeoCoord(gcoor,EGeoCoordDisplayMode.Longitude_Only)
	
	if gcity == L"" then
		gcity = gcountry
	else
		gcity = gcountry .. L" " .. gcity .. L", " .. gstreet
    end
	
	ui.gjUserPositionList:add({plat=glat, plong=glong, paddr=gcity, pdate=sc_DateToWStr(MODEL.gps.current_date()), ptime=MODEL.other.format_time_dayperiod(MODEL.gps.current_time(), 0, 0), pspeedlim=SpeedLimit,  pspeed=CurrentSpeed,  ptype=PosType})
	MODEL.ui.gjUserPositionList.save()
	MODEL.lua.gjPISetShow = false
	MODEL.lua.gjPosIcon = tonumber(PosType)
	sc_gjShowHelpText(m_i18n("Position saved!"), "speedwarn_list.bmp#32")
end


sc_gj_UserPositionDel_OnRelease = function()
	local index = MODEL.ui.gjUserPositionList.index()
	local text = translated_format(m_i18n("Are you sure you want to delete this position from list?"))
	MODEL.screen.msgbox.new.setup(2)
	MODEL.screen.msgbox.new.set_line_wstr(1, text)
---	MODEL.screen.msgbox.new.set_line_wstr(2, MODEL.ui.gjUserPositionList[index].plat() .. L" " .. MODEL.ui.gjUserPositionList[index].plong())
	MODEL.screen.msgbox.new.setup_button(1, "sc_gjUserPositionDel_OnRelease_OK", m_i18n("Delete"), L"", "ico_del_sml.bmp#3")
	MODEL.screen.msgbox.new.setup_button(2, "", m_i18n("Cancel"), L"", "ico_cancel_mid.bmp#3")
	MODEL.screen.msgbox.create_new()
end

sc_gjUserPositionDel_OnRelease_OK = function()
	MODEL.ui.gjUserPositionList.remove(MODEL.ui.gjUserPositionList.list.index())
	MODEL.ui.gjUserPositionList.save()
end


sc_gj_UserPositionAll_OnRelease = function()
	local text = translated_format(m_i18n("Are you sure you want to delete all positions from list?"))
	MODEL.screen.msgbox.new.setup(2)
	MODEL.screen.msgbox.new.set_line_wstr(1, text)
	MODEL.screen.msgbox.new.setup_button(1, "sc_gjUserPositionAll_OnRelease_OK", m_i18n("Delete All"), L"", "ico_DeleteAll_mid.bmp#3")
	MODEL.screen.msgbox.new.setup_button(2, "", m_i18n("Cancel"), L"", "ico_cancel_mid.bmp#3")
	MODEL.screen.msgbox.create_new()
end


sc_gjUserPositionAll_OnRelease_OK = function()
	MODEL.ui.gjUserPositionList.clear()
	MODEL.ui.gjUserPositionList.save()
end
 
sc_gjUserPositionFindOnRelease = function()
	local index = MODEL.ui.gjUserPositionList.index()
	local plat = MODEL.ui.gjUserPositionList[index].plat()
	local plong = MODEL.ui.gjUserPositionList[index].plong()
	if MODEL.lua.Utm() then
		local zone_number, zone_letter = parse_zone(MODEL.lua.gcoor_zonetext())
		MODEL.lua.gcoor_to_find = GCOOR.new({zone_number = zone_number, zone_letter = zone_letter, x = tonumber(plat), y = tonumber(plong)})
	else
		local temp = var.new()
		temp:SET(plat)
		MODEL.regional.unlocalize_gcoor(temp)
		local geocoord_input_lat = parse_gcoor(tostring(temp()))
		ASSERT(geocoord_input_lat ~= nil)
		temp:SET(plong)
		MODEL.regional.unlocalize_gcoor(temp)
		local geocoord_input_lon = parse_gcoor(tostring(temp()))
		ASSERT(geocoord_input_lon ~= nil)
		MODEL.lua.gcoor_to_find = GCOOR.new({lat = geocoord_input_lat, lon = geocoord_input_lon})
	end
	
	MODEL.lua.gjPIShow = true

	local gjTypePosInfo = MODEL["*"].ptype()
	if gjTypePosInfo == L"" then
		gjTypePosInfo = "0"
	end
	MODEL.lua.gjPosIcon = tonumber(gjTypePosInfo)
	
	local text = m_i18n(MODEL["*"].pspeedlim())
	if text == L"0" then
		text = "!"
	end
	gj_plimspeedText:SET(text)	
	gj_pcrspeedText:SET(m_i18n(MODEL["*"].pspeed()) .. L" km/h")
		
	sc_Input_GeoCoord_Ok()
end


st_FindOnMap.exit_orig = st_FindOnMap.exit
st_FindOnMap.exit = function()
  MODEL.lua.gjPIShow = false
  PoiSelected = false
  MODEL.lua.LockToCar = false
  MODEL.lua.ItemHasJustSelected = true
  if gFavoritesSearchStateisEntered then
    inpFPS_PostFilter_Name.value = gFavNameFilter
    sc_SearchFavorites()
    sc_PoiSearch_PostFilter_SetFilterString(ui.inpFPS_PostFilter_Name.value)
  end
  sc_CheckCurrentPOIVis()
  MODEL.poi.resultpoi.clear()
  MODEL.map.primary.clear_clicked_lists()
end


-- postowebsite ------

gj_postoweb_site = ""
gj_postoweb_nick = ""
gj_postoweb_pass = ""
sc_postoweb_OnRelease_OK = function()
	local index = MODEL.ui.gjUserPositionList.index()
	local plat = MODEL.ui.gjUserPositionList[index].plat()
	local plong = MODEL.ui.gjUserPositionList[index].plong()
	local ptype = m_i18n(MODEL.ui.gjUserPositionList[index].ptype())
	local pspeedlim = m_i18n(MODEL.ui.gjUserPositionList[index].pspeedlim())
		
	if ptype == L"4" then 	
		gj_postoweb_site = sc_GetSysEntry("pos_web", "web_site2", L"")
	else
		gj_postoweb_site = sc_GetSysEntry("pos_web", "web_site1", L"")
	end
	
	gj_postoweb_nick = sc_GetSysEntry("pos_web", "web_nick", L"")
	gj_postoweb_pass = sc_GetSysEntry("pos_web", "web_pass", L"")
	local addr = L""..gj_postoweb_site..L"?long="..plong..L"&lati="..plat..L"&catype="..ptype..L"&speed="..pspeedlim..L"&nick="..gj_postoweb_nick..L"&pass="..gj_postoweb_pass
	java:call("android.open_webpage", addr)
	
    killDelayed(gjpostoweb_del)
    gjpostoweb_del = doDelayed(50, function()
		sc_gj_UserPositionDel_OnRelease()
		sc_back()
	end
	)
end


-- route ----------------------------------------------------------------

sc_route_finished_Speedcheck_orig = sc_route_finished_Speedcheck
sc_route_finished_Speedcheck = function()
  if MODEL.navigation.car.current_speed() < 45 and not MODEL.route.list.navigated.calculating() then
    gIdleTime_SpeedCheckTime = gIdleTime_SpeedCheckTime + 1
  else
    gIdleTime_SpeedCheckTime = 0
  end
  if gIdleTime_SpeedCheckTime > 5 then
    sc_route_finished_UIObserver()
    obs_destination_speedcheck:STOP()
  end
end

sc_route_finished_UIObserver_orig = sc_route_finished_UIObserver
sc_route_finished_UIObserver = function()

-- autoshutdown
  if MODEL.lua.vgjAAD_Mode() == 0 then
	-- standard mode --
	if vDestinationReachedPopoUpID() == -1 then
		ui.vDestinationReachedPopoUpID = sc_AddMapPopup(2, m_i18n("Have you arrived at your destination?"), "ico_flag_dest_sml.bmp#3", 1, "sc_GotoDestinationMenu", "", false, nil, 0)
	end
  else
--	if MODEL.gps.connection_status() >= 3 and not MODEL.gps.signal_lost() then
	local gDestETA = MODEL.navigation.eta_at_destination()
	if gDestETA.min ~= 0 then
		--gj auto delete route
		if MODEL.lua.vgjAAD_RouteDelete() then
			sc_DeleteRoute()
		end
		--gj auto save
		if MODEL.lua.vgjAAD_SaveTrip() then
			sc_SaveTripLogAtDestination()
		end
		--gj auto exit
		if MODEL.lua.vgjAAD_Exit() then
	        ui_gjm_AAD_timer:SHOW()
			MODEL.lua.vgjAAD_Tick = MODEL.lua.vgjAAD_ShowTime()
		end
		--gj play sound
		if MODEL.lua.vgjAAD_PlaySound() then
			PLAYSOUND( "arrive" )
		end
	end
  end
end

--gj auto exit
sc_gjCancel_autoexit = function()
  MODEL.lua.vgjAAD_Tick = 0
  ui_gjm_AAD_timer:HIDE()
end

-- other ----------------------------------------------------------------

sc_gjShowHelpText = function(text,ico)
    gj_pType:BMP(ico)
	txtHelpText:TEXT(text)
	if gjShowHelpTextTimer ~= -1 then
		killDelayed(gjShowHelpTextTimer )
		gjShowHelpTextTimer = -1
	end
	ui_gjHelpText:SHOW()
	gjShowHelpTextTimer = doDelayed(100, function()
		ui_gjHelpText:HIDE()
		gj_pType:BMP("")
	end
	)
end 

sc_gj_DoToll = function()
  MODEL.route.allow_toll = not MODEL.route.allow_toll()
  MODEL.route.saverouteparams()
  MODEL.route.recalculate()
  doDelayed(30, function()
	MODEL.lua.vEasyNavMapMenuOpen = false
  end
  )
  MODEL.lua.gjPosIcon = 0
  if MODEL.route.allow_toll() then
	sc_gjShowHelpText(m_i18n("Toll ON"), "ico_done_sml.bmp#3")
  else
	sc_gjShowHelpText(m_i18n("Toll OFF"), "ico_cancel_mid.bmp#3")
  end
end

-- restart
st_SettingColor:useLayers(backgroundLayers, "ui_SettingColorRestart")
sc_akRestart_OnRelease = function()
    MODEL.screen.msgbox.new.setup(2)
    MODEL.screen.msgbox.new.set_line(1, m_i18n("The program will restart."))
    MODEL.screen.msgbox.new.setup_button(1, "sc_akRestart_OnReleaseDone", m_i18n("Restart"), "", "ico_done_mid.bmp#3")
    MODEL.screen.msgbox.new.setup_button(2, "sc_CancelExit", m_i18n("Cancel"), "", "ico_cancel_mid.bmp#3")
    MODEL.screen.msgbox.create_new()
end

sc_akRestart_OnReleaseDone = function()
    SAVESETTINGS()
    NEXTSTATE(RestartState)
    doDelayed(25, APP_RESTART)
end


sc_gj_favorite = function()
  local orientation = MODEL.screen.current_orientation()
  if orientation == 2 or orientation == 4 then
	if MODEL.lua.vEasyNavTripInfoOpen() then
		sc_SelectCockpit_Map()
	else
		sc_map_local_menu_favorite()
	end
  elseif orientation == 1 or orientation == 3 or orientation == 5 or orientation == 6 then
    sc_map_local_menu_favorite()
  end
end

-- blink --------------------------------------------------

sc_gj_blink = function()
  
  if MODEL.navigation.has_route() then
   
	-- arrive time tracking
	if MODEL.lua.vgjATP_Enable() then
		local DestATPETA = MODEL.navigation.eta_at_destination()
		local DestATPTmp = MODEL.lua.vgjATP_TmpTime()
		if DestATPTmp > DestATPETA then
			MODEL.lua.vgjATP_ShowArrTime = (DestATPTmp-DestATPETA)
		else
			MODEL.lua.vgjATP_ShowArrTime = (DestATPTmp-DestATPETA) * -1
		end
	end
	
	-- overview
	if vActiveState() == "st_easynav" and wTemp_overview_distance ~= nil then
		sc_overview_check()
	end

	-- recalc
	if MODEL.lua.vgjRecalcInfo_Enable() then
		if not MODEL.lua.routeCalculation_todo() then 
			if MODEL.navigation.distance_to_destination() > 0 and gjRI_CalckEvent == 0 then
				MODEL.lua.vgjRI_TmpDist = MODEL.navigation.distance_to_destination()
				MODEL.lua.vgjRI_TmpTime = MODEL.navigation.time_to_destination() 
			end	
		end 
	end	

  end

	--gj auto exit
	if MODEL.lua.vgjAAD_Tick() > 0 then
		MODEL.lua.vgjAAD_Tick = MODEL.lua.vgjAAD_Tick() - 1
		txt_gjm_add1:TEXT(translated_format(m_i18n("Shut down after %s sec."), tostring(MODEL.lua.vgjAAD_Tick()))) 
		if MODEL.lua.vgjAAD_Tick() < 1 then 
			if MODEL.lua.vgjAAD_Exit() then
				doDelayed(50,sc_DoExit)
			end	
		end
	end  

  
end	  


--gj navigatemap.lua -------------
wTemp_overview_distance = nil
wTimerExitDragModeID=-1

sc_EasyMapClick_orig = sc_EasyMapClick
sc_EasyMapClick = function()
  local selectedPois = MODEL.map.primary.clicked_poi_list
  if #selectedPois == 1 then
    currentPoi = selectedPois[0]
    MODEL.my.poi.select_poi(currentPoi.provider_id(), currentPoi.id())
  end
  MODEL.lua.IgoSearchPOIhasURL = false
  PoiSelected = false
  gClickedPoiFlag = false
  if #selectedPois and (MODEL.map.primary.zoom():toInt() <= gPoiDistantDistance or st_ShowPoiResultOnMap.isActive) then
    sc_SetPOICursorIcon()
    PoiSelected = true
    gClickedPoiFlag = true
    g_cursor_strapped = true
    if st_FindOnMap.isActive and MODEL.lua.IgoSearch() and MODEL.my.poi.current.provider_id() == MODEL.poi.find_provider(MODEL.lua.featured_provider()) and sc_igosearchlinkparser(MODEL.my.poi.current.address.ext(), L",", "flag") == L"2" then
      MODEL.lua.IgoSearchPOIhasURL = true
    end
  elseif MODEL.map.primary.clicked_tmc_id.valid() then
    MODEL.map.primary.cursor_icon = "cursor_tmc"
    g_cursor_strapped = true
  elseif #MODEL.map.primary.clicked_speedcam_list then
    MODEL.map.primary.cursor_icon = "cursor_speedcam"
    g_cursor_strapped = true
    sc_UpdateSpeedcamModels(MODEL.map.primary.clicked_speedcam_list[0])
  else
    MODEL.map.primary.cursor_icon = "cursor"
    g_cursor_strapped = false
  end
  if MODEL.map.primary.center_follow() then
    obs_enter_drag_mode:STOP()
    sc_dragmode(false)
    obs_enter_drag_mode:START("NO_TRIGGER")
  end
  -- back drag
  if vActiveState() == "st_easynav" and MODEL.lua.dragMode() then
	sc_start_ExitDragMode()
  end 
end

-- auto back from drag

sc_wEasyMapDrag = function()
	if vActiveState() == "st_easynav" and MODEL.lua.dragMode() then
		sc_start_ExitDragMode()
	end
end

sc_start_ExitDragMode = function()
	sc_Kill_wTimerExitDragModeID()
	wTimerExitDragModeID = doDelayed(MODEL.lua.vgjBackToCockpit(), function()
		if not gLocalMenuIsClosed then
			sc_close_local_menu()
		end
		sc_backFromdragmode()
		primary:ONMAPCLICK(sc_EasyMapClick)
		primary:ONMAPDRAGGED(sc_wEasyMapDrag)
	end)
end

sc_do_ExitDragMode = function()
	sc_Kill_wTimerExitDragModeID()
end

sc_Kill_wTimerExitDragModeID = function()
	if wTimerExitDragModeID ~= -1 then
		killDelayed(wTimerExitDragModeID)
		wTimerExitDragModeID = -1
	end
end



st_EasyNav.init_orig = st_EasyNav.init
st_EasyNav.init = function()
    gGotoMapByLongklick = false
    sc_RegisterHWBack("sc_cockpit_back", "sc_DisableDefaultLongBack")
    local messageBoxY = scGetMapPopupY()
    sc_PosRecalcLayer()
    sc_Set_Presets()
    sc_SetOrientation()
    sc_init_local_menu("ui.lm_st_EasyNav")
    primary:ONMAPCLICK(sc_EasyMapClick)
    
-- auto back from drag
  primary:ONMAPDRAGGED(sc_wEasyMapDrag)
  
    obs_enter_drag_mode:START("no_trigger")
    if MODEL.lua.dragMode() then
        sc_dragmode(true)
        MODEL.lua.mainMenuMode = false
    else
        if MODEL.navigation.is_in_simulation() then
            sc_RegisterHWBack("sc_cockpit_back", "sc_longBackFromSim")
            sc_SetFlyOverMode()
        else
            sc_set_Nav2D3D()
            MODEL.lua.mainMenuMode = false
        end
        sc_SetCockpitMap()
-- gj
		sc_gj_zoomcheck()
	
		if MODEL.route.vehicle_type() == EVehicleType.Pedestrian then
			MODEL.map.primary.camera_settings.overview_enabled = false
		elseif MODEL.lua.wUserZoomSetting() then
			sc_Set_wUser_Presets()
		else
			MODEL.map.primary.camera_settings.overview_enabled = (MODEL.lua.wOverviewMode() ~= 0)
		end

        sc_Set_Follow_On()
        MODEL.map.primary.show_cursor = false
        KEY("LOCALMENU", function()
        end
        )
    end
    ATTACH_LANEINFO(sprLaneInfoEasy, "laneinfo.ini")
    ATTACH_LANEINFO(sprLaneInfoSignpost, "laneinfo_signpost.ini")
    ui.bLaneInfoSignpostForceRedraw = 1
    local junctionViewType = sc_GetSysEntry("navigation", "junction_view_type", "NNG")
    gJunctionViewNeedsSignpost = sc_GetSysEntry("navigation", "junction_view_needs_signpost", true)
    if junctionViewType == "NNG" then
        ATTACH_JUNCTIONVIEW(sprJunctionView, junctionViewIni[junctionViewType], gJunctionViewDirectory)
    elseif junctionViewType == "mixed" then
        ATTACH_JUNCTIONVIEW(sprJunctionView, junctionViewIni[junctionViewType], gJunctionViewDirectory .. ";" .. gJunctionViewContentResolution)
    elseif junctionViewType == "NNG_NQ" then
        ATTACH_JUNCTIONVIEW(sprJunctionView, junctionViewIni[junctionViewType], "16_9_NQ_Roads")
    elseif junctionViewType == "NQ" then
        ATTACH_JUNCTIONVIEW(sprJunctionView, junctionViewIni[junctionViewType], gJunctionViewDirectory .. ";" .. gJunctionViewContentResolution)
    end
    if MODEL.map.primary.state() == "2dnorthup" or MODEL.map.primary.state() == "simulate_2d_nu" then
        ui_SimulationControls:Y(uiResH * 32 / 100)
        MODEL.map.primary.car_posy = 50
    else
        ui_SimulationControls:Y(0)
        MODEL.map.primary.car_posy = 78
    end
    st_EasyNav.active = true
    obs_want_junctionview:START()
    obs_TunnelOverview:START()
    ui_Local_Menu_Background.ALPHA = 0
    ui_Local_Menu_Background_Disabled:HIDE()
    sc_CloseMapLocalMenu(true)
    if not MODEL.map.primary.center_follow() and not gKeepMapPosAfterBack then
        MODEL.map.primary.center_noanim(MODEL.map.cursor.position())
    end
    gKeepMapPosAfterBack = false
    MODEL.mydata.tracks.show_on_map = MODEL.lua.TrackShowOnMap()
    if showDriveCarefully and MODEL.interface.drive_carefully() then
        sc_drive_carefully_init()
    end
    ui.vTmcButtonBlinkCounter = 0
    ui.vDAIsVisible = 1
    MODEL.traffic.events.sort_by("distance")
    sc_UpdateFullDelayTextOnMap()
    satPhaseTimerId = doDelayed(20, sc_CycleSatPhase, true)
    MODEL.lua.ismapvisible = true
    MODEL.navigation.restrictions_turn_change_handler = sc_TruckTurnRestrictionAlert
    
--gj rest turn
	if MODEL.lua.vgjShowRestTurn() and MODEL.lua.vgjSoundRestTurn() then
		obs_gj_turnrest:START("NO_TRIGGER")
		if MODEL.navigation.turn_restriction_icon.valid() then
			obs_gj_turnrest_chg:START("NO_TRIGGER")
		end
	end
  
    if ui.bLaneinfoSignpostValid then
        sc_SignPostLayerShow()
    end
end
 
 
st_EasyNav.mode_landscape_orig = st_EasyNav.mode_landscape
st_EasyNav.mode_landscape = function()
    local isPanelOpen = not MODEL.lua.dragMode() and MODEL.lua.HwyPoiListIsVisible() or MODEL.screen.msgbox.is_onscreen()
    if MODEL.lua.vMapMenuOpen() then
        ui_MapLocalMenuListLayer.Y = 0
    else
        ui_MapLocalMenuListLayer.Y = uiResH
    end
    MODEL.lua.vEasyNavTripInfoPrevStatus = MODEL.lua.vEasyNavTripInfoOpen()
    MODEL.lua.vEasyNavTripInfoOpen = true
    sc_reset_primary(false)
    sc_SetNavCarPos(isPanelOpen)
    if MODEL.lua.JunctionViewVisible() then
        ATTACH_TUNNELOVERVIEW(sprTunnelOverview)
    else
        ATTACH_TUNNELOVERVIEW(sprTunnelOverview2)
    end
    MODEL.lua.NavigationStatusbarViaRefreshHack = true
-- gj
    sc_gj_zoomcheck()
end
 

st_EasyNav.mode_portrait_orig = st_EasyNav.mode_portrait
st_EasyNav.mode_portrait = function()
    local isPanelOpen = not MODEL.lua.dragMode() and MODEL.lua.HwyPoiListIsVisible() or MODEL.screen.msgbox.is_onscreen()
    if MODEL.lua.vMapMenuOpen() then
        ui_MapLocalMenuListLayer.Y = 0
    else
        ui_MapLocalMenuListLayer.Y = uiResH
    end
    MODEL.lua.vEasyNavTripInfoPrevStatus = MODEL.lua.vEasyNavTripInfoOpen()
    MODEL.lua.vEasyNavTripInfoOpen = true
    sc_reset_primary(false)
    sc_SetNavCarPos(isPanelOpen)
    if MODEL.lua.JunctionViewVisible() then
        ATTACH_TUNNELOVERVIEW(sprTunnelOverview)
    else
        ATTACH_TUNNELOVERVIEW(sprTunnelOverview2)
    end
    MODEL.lua.NavigationStatusbarViaRefreshHack = false
-- gj
    sc_gj_zoomcheck()
end

 
st_EasyNav.done_orig = st_EasyNav.done
st_EasyNav.done = function()
  -- auto back from drag
	sc_Kill_wTimerExitDragModeID()

	sc_reset_primary(true)
    sc_SetNavCarPos(false)
    MODEL.lua.vEasyNavTripInfoPrevStatus = MODEL.lua.vEasyNavTripInfoOpen()
    killDelayed(satPhaseTimerId)
    ui_Quick_Menu_Background.ALPHA = 0
    ui_Quick_Menu_Background_Disabled:HIDE()
    MODEL.screen.msgbox.pause_tags("popup", true)
    obs_enter_drag_mode:STOP()
    st_EasyNav.active = nil
    obs_want_junctionview:STOP()
    obs_TunnelOverview:STOP()
  
  -- gj zoom overview
	obs_wOverviewHighwayFlag:STOP()
	obs_wOverviewFlag:STOP()
  
    ATTACH_TUNNELOVERVIEW()
    MODEL.navigation.want_junctionview = false
    MODEL.mydata.tracks.show_on_map = false
    obs_user_browsing_map:STOP()
    obs_clicked_tmc_id_changed:STOP()
    MODEL.traffic.events.sort_by(MODEL.lua.trafficEventSorting())
    MODEL.lua.ismapvisible = false
    obs_CloseMapMenu:STOP()
    MODEL.navigation.restrictions_turn_change_handler = nil
    sc_HWBackReset()
end




sc_SignPostLayerShow_orig = sc_SignPostLayerShow
sc_SignPostLayerShow = function()
  if st_EasyNav.active and not MODEL.lua.SignpostIsValid() and MODEL.lua.SignpostOn() then
	sc_Angle_SP()
	--sound
	if MODEL.lua.vgjLaneSound() then
		PLAYSOUND("alarmeffect", "lane")
	end
    MODEL.lua.SignpostIsValid = true
    ui_NavigateMapSingpost.Y = -vLaneInfoSignpostHeight()
    ui_NavigateMapSingpost:YBLEND(0, 15)
  end
  obs_want_junctionview:TRIGGER()
end


-- lane sound

sc_LaneInfoVisibleOnchange_orig = sc_LaneInfoVisibleOnchange 
sc_LaneInfoVisibleOnchange = function()
  if MODEL.lua.laneInfoVisible() then
    sprLaneInfoEasy:BLENDALPHA(0, 32, 20)
	--sound
	if MODEL.lua.vgjLaneSound() then
		PLAYSOUND("alarmeffect", "lane")
	end
  else
    sprLaneInfoEasy:BLENDALPHA(32, 0, 20)
  end
end

--gj zoom overview----------------
wInpValueInteger_min = 0
wInpValueInteger_max = 0
wInpValueInteger_needsign = false
wInpValueInteger_model = ""
wTmpdateDelimiter = nil
wUnitConvMeter2Unit = {float.new("1.093613298"), float.new("1.0"), float.new("3.280839895")}


createState("st_InputValueInteger")
st_InputValueInteger:useLayers(backgroundLayers, ui_InputValueInteger)
st_InputValueInteger.init = function()
	MODEL.lua.easyShowDoneKey = true
	MODEL.regional.keyboard.load_panel_by_name(L"Core Numbers")
	MODEL.lua.InputValidatorIsDate = true
	wTmpdateDelimiter = MODEL.lua.dateDelimiter()
	MODEL.lua.dateDelimiter = 0
end
 
st_InputValueInteger.done = function()
	KEY("RETURN")
	MODEL.regional.keyboard.on_close_panel()
	MODEL.regional.keyboard.smartkey_model("")
end
 
sc_inpValueInteger_onchange = function()
	local inptext = ui.inpValueInteger.VALUE()
	local tempinptext = wstring.sub(inptext, 1, 1) == L"-" and wstring.sub(inptext, 2, #inptext) or inptext
	local acceptable, InputKeys = getNextInput_Int(tempinptext, wInpValueInteger_min, wInpValueInteger_max)
	MODEL.lua.keyb_done = acceptable
	MODEL.lua.fuelinputkeys = InputKeys .. (#inptext == 0 and wInpValueInteger_needsign and L"-" or L"")
	MODEL.regional.keyboard.smartkey_model("lua.fuelinputkeys")
end
 
sc_SelectValueInteger = function(title, donefunction, min, max, needsign, donemodel)
	wInpValueInteger_min = min
	wInpValueInteger_max = max
	wInpValueInteger_needsign = needsign
	if donemodel ~= nil then
		wInpValueInteger_model = donemodel
	end
	local emptytitle = (needsign and (L"-" .. towstring(max)) or towstring(min)) .. L".." .. towstring(max)
	sc_NextStateAnim(st_InputValueInteger, "horz_scroll", 1, "")
	txtTitle.TEXT = m_i18n(title)
	inpValueInteger.value = L""
	inpValueInteger.EMPTYTITLE = translated_format(m_i18n("<Enter Number (%s)>"), emptytitle)
	sc_inpValueInteger_onchange()
	KEY("RETURN", donefunction)
	ui.vKeyTableDone = donefunction
end
 
inpValueInteger_isempty = function()
	local result = var.new()
	inpValueInteger:ISEMPTY(result)
	return result()
end

-- overview zoom

sc_gj_zoomcheck = function()
	wTemp_overview_distance = nil
		
	if MODEL.route.vehicle_type() == EVehicleType.Pedestrian then
		MODEL.map.primary.camera_settings.overview_enabled = false
	elseif MODEL.lua.wUserZoomSetting() then
		sc_Set_wUser_Presets()
	else
		MODEL.map.primary.camera_settings.overview_enabled = (MODEL.lua.wOverviewMode() ~= 0)
	end

	MODEL.lua.wOverviewFlag = false
	if MODEL.map.primary.camera_settings.overview_enabled() then
		wTemp_overview_distance = MODEL.map.primary.camera_settings.overview_distance()
		if not MODEL.lua.wUserZoomSetting() and MODEL.lua.wOverviewMode() == 1 then
			sc_wOverviewHighwayPause()
			obs_wOverviewHighwayFlag:START()
		else
			obs_wOverviewFlag:START("NO_TRIGGER")
		end
	end
	
end
 
sc_ExitOverview = function()
	MODEL.map.primary.camera_settings.overview_distance = 9999999
end

sc_wOverviewHighwayPause = function()
	MODEL.map.primary.camera_settings.overview_distance = 9999999
end

sc_wOverviewReset = function()
	if MODEL.map.primary.camera_settings.overview_distance() == 9999999 and wTemp_overview_distance ~= nil then
		MODEL.map.primary.camera_settings.overview_distance = wTemp_overview_distance
        return 1
	end
end
 
sc_overview_check = function()
	MODEL.lua.wOverviewFlag = (wTemp_overview_distance < MODEL.navigation.distance_to_maneuver())
end

sc_jgOverview_on_off = function()
    if MODEL.lua.wOverviewMode() ~= 0 then
        MODEL.lua.gjPosIcon = 0
        if MODEL.map.primary.camera_settings.overview() then 
            sc_ExitOverview()
            sc_gjShowHelpText(m_i18n("Overview OFF"), "ico_cancel_mid.bmp#3")
        else
		local akovret = sc_wOverviewReset()
            if akovret == 1 then
                sc_gjShowHelpText(m_i18n("Overview ON"), "ico_done_sml.bmp#3")
            end
        end	
    end
end


sc_MapSettings_Zoom = function()
	sc_NextStateAnim(st_MapSettings_Zoom, "horz_scroll", 1, "")
end

sc_ConvertInputDistToCurrent = function(dist)
	return float.toInt(float.new(tostring(dist)) * wUnitConvMeter2Unit[MODEL.INT.regional.units() + 1])
end
 
sc_Select_wZoom_minangleDone = function()
	if not inpValueInteger_isempty() then
		local text = tonumber(ui.inpValueInteger.VALUE())
		MODEL.lua.wZoom_minangle = text
		if MODEL.lua.wZoom_maxangle() < text then
			MODEL.lua.wZoom_maxangle = text
		end
		if MODEL.lua.wZoom_maxangleSP() < text then
			MODEL.lua.wZoom_maxangleSP = text
		end
	end
	PREVSTATE()
end
 
sc_Select_wZoom_maxangleDone = function()
	if not inpValueInteger_isempty() then
		local text = tonumber(ui.inpValueInteger.VALUE())
		MODEL.lua.wZoom_maxangle = text
		if MODEL.lua.wZoom_minangle() > text then
			MODEL.lua.wZoom_minangle = text
		end
		if MODEL.lua.wZoom_maxangleSP() < text then
			MODEL.lua.wZoom_maxangleSP = text
		end
	end
	PREVSTATE()
end
 
sc_Select_wZoom_maxangleSPDone = function()
	if not inpValueInteger_isempty() then
		local text = tonumber(ui.inpValueInteger.VALUE())
		MODEL.lua.wZoom_maxangleSP = text
		if MODEL.lua.wZoom_maxangle() > text then
			MODEL.lua.wZoom_maxangle = text
		end
		if MODEL.lua.wZoom_minangle() > text then
			MODEL.lua.wZoom_minangle = text
		end
	end
	PREVSTATE()
end
 
sc_Select_wZoom_speedlowDone = function()
	if not inpValueInteger_isempty() then
		local text = tonumber(ui.inpValueInteger.VALUE())
		if MODEL.regional.units() ~= 1 then
			text = regional.units:convert("Speed", "km/h", text, "miles/hour")
			text = double.round(text):toInt()
		end
		MODEL.lua.wZoom_speedlow = text
		if MODEL.lua.wZoom_speedhigh() < text then
			MODEL.lua.wZoom_speedhigh = text
		end
	end
	PREVSTATE()
end
 
sc_Select_wZoom_speedhighDone = function()
	if not inpValueInteger_isempty() then
		local text = tonumber(ui.inpValueInteger.VALUE())
		if MODEL.regional.units() ~= 1 then
			text = regional.units:convert("Speed", "km/h", text, "miles/hour")
			text = double.round(text):toInt()
		end
		MODEL.lua.wZoom_speedhigh = text
		if MODEL.lua.wZoom_speedlow() > text then
			MODEL.lua.wZoom_speedlow = text
		end
	end
	PREVSTATE()
end

sc_SelectIntegerDistanceDone = function()
	if not inpValueInteger_isempty() then
		MODEL[wInpValueInteger_model] = float.toInt(float.new(tostring(ui.inpValueInteger.VALUE()))/ wUnitConvMeter2Unit[MODEL.INT.regional.units() + 1])
	end
	PREVSTATE()
end

sc_SelectIntegerNumberDone = function()
	if not inpValueInteger_isempty() then
		MODEL[wInpValueInteger_model] = tonumber(ui.inpValueInteger.VALUE())
	end
	PREVSTATE()
end

createState("st_MapSettings_Zoom")
st_MapSettings_Zoom:useLayers(backgroundLayers, ui_List_Background, ui_MapSettings_Zoom)
st_MapSettings_Zoom.init = function()
	txtTitle.TEXT = m_i18n("User zoom settings")
end


sc_RestoreSmartZoom_orig = sc_RestoreSmartZoom
sc_RestoreSmartZoom = function()
  local mapLayer = MODEL.map.primary()
	MODEL.lua.showLaneInfo = true
	sc_Angle_notSP()
  mapLayer.camera_settings.roundabout.centery = 50
  if MODEL.lua.vEasyMapMode() == EMapMode.Mode_2D then
    if MODEL.route.vehicle_type() == EVehicleType.Pedestrian then
      mapLayer.car_posy = 70
    else
      mapLayer.car_posy = 78
    end
  elseif MODEL.lua.vEasyMapMode() == EMapMode.Mode_2D_NU then
    mapLayer.car_posy = 50
  else
    mapLayer.car_posy = 78
  end
  mapLayer.camera_settings.presetid = MODEL.lua.vEasyViewMode() + 1
end


st_MapSettings_Zoom.exit = function()
	sc_Set_Presets()
end


sc_Angle_SP = function()
	local camerasettings = MODEL.map.primary.camera_settings()
	camerasettings.restore()
	camerasettings.roundabout.centery = 65
	camerasettings.presetid = 10 * (MODEL.lua.vEasyViewMode() + 1) + 1
	if MODEL.route.vehicle_type() == EVehicleType.Pedestrian then
		camerasettings.overview_enabled = false
	elseif MODEL.lua.wUserZoomSetting() then
		sc_Set_wUser_Presets()
		camerasettings.maxangle = MODEL.lua.wZoom_maxangleSP()
		camerasettings.angleoffset = MODEL.lua.wZoom_maxangleSP()
		camerasettings.defaultangle = MODEL.lua.wZoom_maxangleSP()
	else
		camerasettings.overview_enabled = (MODEL.lua.wOverviewMode() ~= 0)
	end
end
 
sc_Angle_notSP = function()
	local mapLayer = MODEL.map.primary()
	mapLayer.camera_settings.restore()
	mapLayer.camera_settings.roundabout.centery = 50
	mapLayer.car_posy = (MODEL.lua.vEasyMapMode() == EMapMode.Mode_3D and 80 or (MODEL.lua.vEasyMapMode() == 3 and 50 or (MODEL.route.vehicle_type() == EVehicleType.Pedestrian and 70 or 80)))
	mapLayer.camera_settings.presetid = MODEL.lua.vEasyViewMode() + 1
	if MODEL.route.vehicle_type() == EVehicleType.Pedestrian then
		mapLayer.camera_settings.overview_enabled = false
	elseif MODEL.lua.wUserZoomSetting() then
		sc_Set_wUser_Presets()
	else
		mapLayer.camera_settings.overview_enabled = (MODEL.lua.wOverviewMode() ~= 0)
	end
end
 
 
sc_Set_Presets_orig = sc_Set_Presets
sc_Set_Presets = function()
	if MODEL.route.vehicle_type() == EVehicleType.Pedestrian then
		sc_Set_Pedestrian_Presets()
	end
	MODEL.map.primary.camera_settings.restore()
	MODEL.map.primary.camera_settings.presetid = MODEL.lua.vEasyViewMode() + 1
	if MODEL.route.vehicle_type() == EVehicleType.Pedestrian then
		MODEL.map.primary.camera_settings.overview_enabled = false
	elseif MODEL.lua.wUserZoomSetting() then
		sc_Set_wUser_Presets()
	else
		MODEL.map.primary.camera_settings.overview_enabled = (MODEL.lua.wOverviewMode() ~= 0)
	end
end

sc_Set_wUser_Presets = function()
	local settings = MODEL.map.primary.camera_settings()
	sc_Set_wUser_Presets_followzoom()
	settings.minangle = MODEL.lua.wZoom_minangle()
	settings.maxangle = MODEL.lua.wZoom_maxangle()
	settings.angleoffset = MODEL.lua.wZoom_maxangle()
	settings.defaultangle = MODEL.lua.wZoom_maxangle()
	settings.lowspeed = MODEL.lua.wZoom_speedlow()
	settings.highspeed = MODEL.lua.wZoom_speedhigh()
	if not MODEL.lua.wZoom_lockzoom() then
		settings.speedzoom = MODEL.lua.wZoom_speedzoom()
		if MODEL.lua.wZoom_speedzoom() then
			settings.speedzoom_use_minmax = true
		end
	end
	settings.speedangle = MODEL.lua.wZoom_speedangle()
	if MODEL.lua.wZoom_speedangle() then
		settings.speedangle_use_minmax = true
	end
	settings.overview_enabled = MODEL.lua.wZoom_overview_enabled() and not MODEL.lua.wZoom_lockzoom()
	if MODEL.lua.wZoom_overview_enabled() then
		settings.overview_distance = MODEL.lua.wZoom_overview_distance()
		settings.overview_zoom2d = MODEL.lua.wZoom_overview_zoom2d()
		settings.overview_zoom3d = MODEL.lua.wZoom_overview_zoom3d()
		settings.overview_angle = MODEL.lua.wZoom_overview_angle()
	end
end
 
sc_Set_wUser_Presets_followzoom = function()
	if MODEL.lua.wUserZoomSetting() and MODEL.lua.wZoom_lockzoom() then
		MODEL.map.primary.zoom_follow = false
		MODEL.map.primary.zoom = false
		MODEL.map.primary.zoom = (MODEL.map.primary.mode() == "3d" and MODEL.lua.wZoom_defaultzoom3d() or MODEL.lua.wZoom_defaultzoom2d())
	else
		MODEL.map.primary.zoom_follow = not MODEL.lua.dragMode()
	end
end
 
  
sc_Easy3D = function()
	local mapLayer = MODEL.map.primary()
	mapLayer.save_state(mapLayer.state())
	mapLayer.switch_state("navmap3d", 1)
	mapLayer.mode = "3d"
	if MODEL.route.vehicle_type() == EVehicleType.Pedestrian then
		sc_Set_Pedestrian_Presets_3D()
		mapLayer.zoom_follow = false
		mapLayer.tilt_follow = false
	elseif not MODEL.lua.dragMode() then
		sc_Set_wUser_Presets_followzoom()
		mapLayer.tilt_follow = true
	end
	if not MODEL.lua.dragMode() then
		mapLayer.center_follow = true
		mapLayer.rotate_follow = true
	end
end
 
sc_Easy2D = function()
	local mapLayer = MODEL.map.primary()
	mapLayer.save_state(mapLayer.state())
	mapLayer.switch_state("2dheadup", 1)
	mapLayer.mode = "2d"
	if MODEL.route.vehicle_type() == EVehicleType.Pedestrian then
		sc_Set_Pedestrian_Presets_2D()
		mapLayer.zoom_follow = false
		mapLayer.car_posy = 70
		mapLayer.center_posy = 70
	elseif not MODEL.lua.dragMode() then
		sc_Set_wUser_Presets_followzoom()
		mapLayer.car_posy = 80
		mapLayer.center_posy = 80
	end
	if not MODEL.lua.dragMode() then
		mapLayer.center_follow = true
		mapLayer.rotate_follow = true
	end
	mapLayer.breadcrumbs = MODEL.route.vehicle_type() == EVehicleType.Pedestrian
end

sc_Easy2D_NU = function()
	local mapLayer = MODEL.map.primary()
	mapLayer.save_state(mapLayer.state())
	mapLayer.switch_state("2dnorthup", 1)
	if MODEL.route.vehicle_type() == EVehicleType.Pedestrian then
		sc_Set_Pedestrian_Presets_2D()
	end
	mapLayer.zoom_follow = true
	mapLayer.car_posy = 50
	mapLayer.center_posy = 50
	if not MODEL.lua.dragMode() then
		sc_Set_wUser_Presets_followzoom()
		mapLayer.center_follow = true
		mapLayer.rotate = 0
		mapLayer.rotate_follow = false
	end
	mapLayer.breadcrumbs = MODEL.route.vehicle_type() == EVehicleType.Pedestrian
end

sc_Easy3DFromDragmode = function()
	local mapLayer = MODEL.map.primary()
	MODEL.lua.dragMode = false
	MODEL.lua.tiltVisible = false
	mapLayer.switch_state("navmap3d", 1)
	if MODEL.route.vehicle_type() == EVehicleType.Pedestrian then
		mapLayer.zoom_follow = false
		mapLayer.tilt_follow = false
		mapLayer.rotate_follow = false
	else
		sc_Set_wUser_Presets_followzoom()
		mapLayer.tilt_follow = true
		mapLayer.rotate_follow = true
	end
end
 
sc_Easy2DFromDragmode = function()
	local mapLayer = MODEL.map.primary()
	MODEL.lua.dragMode = false
	MODEL.lua.tiltVisible = false
	mapLayer.switch_state("2dheadup", 1)
	if MODEL.route.vehicle_type() == EVehicleType.Pedestrian then
		mapLayer.zoom_follow = false
		mapLayer.breadcrumbs = true
		mapLayer.center_posy = 50
	else
		sc_Set_wUser_Presets_followzoom()
		mapLayer.breadcrumbs = false
		mapLayer.center_posy = 80
	end
end
 
sc_Easy2D_NU_FromDragmode = function()
	local mapLayer = MODEL.map.primary()
	MODEL.lua.dragMode = false
	MODEL.lua.tiltVisible = false
	mapLayer.switch_state("2dnorthup", 1)
	mapLayer.breadcrumbs = MODEL.route.vehicle_type() == EVehicleType.Pedestrian
	sc_Set_wUser_Presets_followzoom()
	mapLayer.center_posy = 50
	mapLayer.car_posy = 50
end
 
sc_set_3dDem = function()
	local value = MODEL.map.primary["3d_dem"]()
	local valueNeg = 0
	if value == 0 then
		valueNeg = 3
	end
	MODEL.map.primary.setglobal = true
	MODEL.map.primary.setglobal_filter = wGetNUSupported and "navmap3d,2dheadup,2dnorthup,simulate,simulate_2d,simulate_2d_nu" or "navmap3d,2dheadup,simulate,simulate_2d"
	MODEL.map.primary["3d_dem"] = valueNeg
	MODEL.map.primary["3d_dem"] = value
	MODEL.map.primary.setglobal = false
end
 
sc_Set_Follow_On = function()
	local mapLayer = MODEL.map.primary()
	if MODEL.route.vehicle_type() ~= EVehicleType.Pedestrian then
		sc_Set_wUser_Presets_followzoom()
		mapLayer.tilt_follow = true
	end
	mapLayer.center_follow = true
	mapLayer.rotate_follow = mapLayer.state() ~= "2dnorthup" and mapLayer.state() ~= "simulate_2d_nu"
	if mapLayer.state() == "2dnorthup" or mapLayer.state() == "simulate_2d_nu" then
		mapLayer.rotate = 0
	end
end

sc_3DFlyOverModeOff_Easy = function()
	obs_flyover_stopped:STOP()
	MODEL.navigation.autoreplan = true
	MODEL.route.list.navigated.waypoints.autocreate_start = MODEL.navigation.autoreplan()
	if MODEL.lua.simulateIsDemo() then
		MODEL.lua.simulateIsDemo = false
		MODEL.route.list.navigated.clear()
	else
		primary:ONMAPCLICK(sc_EasyMapClick)
	end
	if MODEL.lua.wSimulateIsTrackPlaying() then
		MODEL.route.list.wblockroute.clear()
		MODEL.route.load_from_buffer(true)
		sc_CheckOffroadParams()
		sc_UpdateRouteParams()
		MODEL.route.list.navigated.settings.check_consistency_with_global_settings()
		MODEL.lua.wSimulateIsTrackPlaying = false
	end
	local primary = MODEL.map.primary
	if primary.state() == "simulate_2d_nu" or primary.state() == "simulate_2d" or primary.state() == "simulate" then
		obs_enter_drag_mode:STOP()
		primary.exit_state()
		obs_enter_drag_mode:START("NO_TRIGGER")
	end
	if gSimulationEndPrevstate then
		gSimulationEndPrevstate = false
		sc_back()
	end
	if gDetourAcceptanceMode_BeforeSimulation ~= -1 then
		MODEL.traffic.settings.detour_acceptance_mode = gDetourAcceptanceMode_BeforeSimulation
		gDetourAcceptanceMode_BeforeSimulation = -1
	end
	MODEL.screen.msgbox.switch_on()
end

createState("st_wSimulateFromCockpit")
st_wSimulateFromCockpit.init = function()
	if gSimulationEndPrevstate then
		sc_Simulate_Navigation()
	else
		doDelayed(1, function() CLEARTOSTATE(st_EasyNav) end)
	end
end

sc_wSimulate_Navigation_OnRelease_Quick_menu = function()
	gSimulationEndPrevstate = true
	sc_NextStateAnim(st_wSimulateFromCockpit, "fade", 1, "")
end


 
 
 
-- settings -----------------------------------------------------

-- menu settings
createState("st_gj_Settings")
st_gj_Settings:useLayers(backgroundLayers, ui_gj_Settings)
st_gj_Settings.init = function()
	txtTitle:SET(m_i18n("Skin Settings"))
end

sc_btnASM_gj_OnRelease = function()
  sc_NextStateAnim(st_gj_Settings, "horz_scroll", 1, "")
end
 
-- arrive --------------------------------------------------
createState("st_gj_arrive_settings")
st_gj_arrive_settings:useLayers(backgroundLayers, ui_gj_arrive_settings)
st_gj_arrive_settings.init = function()
  txtTitle:SET(m_i18n("Arrive Settings"))
end

sc_gj_arrive_OnRelease = function()
  sc_NextStateAnim(st_gj_arrive_settings, "horz_scroll", 1, "")
end

-- Transparency Settings --------------------------------------------------
createState("st_gj_transparent_settings")
st_gj_transparent_settings:useLayers(backgroundLayers, ui_gj_transparent_settings)
st_gj_transparent_settings.init = function()
  txtTitle:SET(m_i18n("Transparency Settings"))
end

sc_gj_transparent_OnRelease = function()
  sc_NextStateAnim(st_gj_transparent_settings, "horz_scroll", 1, "")
end

-- cockpit settings --------------------------------------------------
createState("st_gj_cockpit_settings")
st_gj_cockpit_settings:useLayers(backgroundLayers, ui_gj_cockpit_settings)
st_gj_cockpit_settings.init = function()
  txtTitle:SET(m_i18n("Cockpit Settings"))
end

sc_gj_cockpit_OnRelease = function()
  sc_NextStateAnim(st_gj_cockpit_settings, "horz_scroll", 1, "")
end

-- more settings --------------------------------------------------
createState("st_gj_more_settings")
st_gj_more_settings:useLayers(backgroundLayers, ui_gj_more_settings)
st_gj_more_settings.init = function()
  txtTitle:SET(m_i18n("More Settings"))
end

sc_gj_more_OnRelease = function()
  sc_NextStateAnim(st_gj_more_settings, "horz_scroll", 1, "")
end


-- gj poi visibility ----------------------------------------------
wCurrentGroup = 0
wCurrentGroupFav = -1
wAddPOIposition	= 0
wGroupIcon = nil
wGroupIconVisibility = nil
wGroupInheritVisibility = nil
wGroupNameVisibility = nil
wGroupDistanceVisibility = nil

createState("st_ManagePOIGroupVisibility")
st_ManagePOIGroupVisibility:useLayers(ui_Title, ui_Status, ui_Background, ui_ManagePOIGroupVisibility, uieffect)
st_ManagePOIGroupVisibility.init = function()
	txtTitle.TEXT = m_i18n("Set Place Visibility")
end
 
st_ManagePOIGroupVisibility.exit = function()
	sc_wUserPOISearchParams_CheckRemoved()
end
 
 sc_ManagePOIGroupVisibility = function()
	wCurrentGroup = MODEL["*"].id()
	MODEL.lua.wSettingDistOn = MODEL["*"].writable()
	MODEL.lua.wSettingDistVisual = MODEL["*"].icon()
	MODEL.lua.wSettingDistSound = MODEL["*"].has_child()
	MODEL.lua.wSettingDistSoundName = MODEL["*"].name()
	MODEL.my.poi.select_group(wCurrentGroup)
	MODEL.lua.wPoiGroupAltitude = MODEL.my.poi.current_group[tostring(MODEL.lua.poi.selectedPOIVis())].visible_at()
	wGroupIconVisibility = MODEL.lua.wSettingDistVisual()
	wGroupNameVisibility = MODEL.lua.wSettingDistSoundName()
	wGroupDistanceVisibility = MODEL.lua.wPoiGroupAltitude()
	wGroupInheritVisibility = MODEL.poi.inherit_visibility()
	sc_NextStateAnim(st_ManagePOIGroupVisibility, "horz_scroll", 1, "")
end

st_LoadPOIVisibilities.init_orig = st_LoadPOIVisibilities.init
st_LoadPOIVisibilities.init = function()
	txtTitle.TEXT = m_i18n("Load Place Marker Settings")
--?
	sc_init_local_menu("ui.moremenu_poivisibility")
end
 
sc_Poi_Visibilities_orig = sc_Poi_Visibilities
sc_Poi_Visibilities = function()
	sc_ForcePoiInit()
	sc_SetPoiVisibilities()
	MODEL.poi.structure.reset()
	MODEL.poi.structure.clear_providers()
	MODEL.poi.structure.add_provider(MODEL.poi.find_provider("ropoi"))
	MODEL.poi.structure.add_provider(MODEL.poi.find_provider("kmlpoi"))
	MODEL.poi.structure.add_provider(MODEL.poi.find_provider("userpoi"))
	MODEL.poi.structure.add_provider(MODEL.poi.find_provider("picturepoi"))
	MODEL.lua.poi.selectedPOIVis = MODEL.poi.structure.visibility_array()
	MODEL.poi.structure.sort = "name"
	MODEL.poi.structure.execute()
	sc_NextStateAnim(st_POIVisibilities, "horz_scroll", 1, "")
end 
 

sc_PoiVisibilityListClearAll_OnRelease_orig = sc_PoiVisibilityListClearAll_OnRelease
sc_PoiVisibilityListClearAll_OnRelease = function()
--?
	sc_close_local_menu()
	
	MODEL.screen.msgbox.new.setup(2)
	MODEL.screen.msgbox.new.set_line(1, m_i18n("Are you sure you want to delete all Place Marker configurations?"))
	MODEL.screen.msgbox.new.setup_button(1, "sc_PoiVisibilityClearAll_OnRelease_OK", m_i18n("Delete All"), "", "ico_DeleteAll_mid.bmp#3")
	MODEL.screen.msgbox.new.setup_button(2, "", m_i18n("Cancel"), "", "ico_cancel_mid.bmp#3")
	MODEL.screen.msgbox.create_new()
end
 
st_POIVisibilities.enter_orig = st_POIVisibilities.enter
st_POIVisibilities.enter = function()
	EPoiScrollPos = {}
	wCurrentGroupFav = MODEL.poi.find_group(FavGroup)
end
 
st_POIVisibilities.done_orig = st_POIVisibilities.done
st_POIVisibilities.done = function()
end
 
sc_back_POIGroupVisibility = function()
	local action = false
	if wGroupIconVisibility ~= MODEL.lua.wSettingDistVisual() then
		MODEL.my.poi.current_group.icon = MODEL.lua.wSettingDistVisual()
		action = true
	end
	if wGroupNameVisibility ~= MODEL.lua.wSettingDistSoundName() then
		local newname = L"@"..MODEL.lua.wSettingDistSoundName()
		MODEL.my.poi.rename_group(wCurrentGroup, newname, MODEL.poi.find_provider("userpoi"))
		action = true
	end
	if wGroupDistanceVisibility ~= MODEL.lua.wPoiGroupAltitude() or wGroupInheritVisibility ~= MODEL.poi.inherit_visibility() then
		MODEL.my.poi.current_group[tostring(MODEL.lua.poi.selectedPOIVis())].visible_at = MODEL.lua.wPoiGroupAltitude()
		action = true
	end
	if action then
		MODEL.poi.structure.execute()
		sc_SavePOIVisibility()
	end
	sc_back()
end

--change poi icons

createState("st_ManagePOIGroupIcon")
st_ManagePOIGroupIcon:useLayers(backgroundLayers, ui_ManagePOIGroupIcon)
st_ManagePOIGroupIcon.init = function()
	txtTitle.TEXT = m_i18n("Select Place Icon")
end

sc_ChangeCurrentPoiGroupIcon = function(group)
	wGroupIcon = group
	if not sc_GetSysEntry("poi", "sort_icons", 1) then
		MODEL.screen.filter_unique_by_index(2)
		MODEL.screen.set_current_icongroup("poi")
	elseif MODEL.ui.list_wScreenIcons.isempty() then
		MODEL.screen.filter_unique_by_index(2)
		MODEL.screen.set_current_icongroup("poi")
		local iconbmp, iconphase = nil, nil
		for i = 0, MODEL.screen.icons.size() - 1 do
			iconbmp, iconphase = MODEL.screen.get_icon_file_and_phase(MODEL.screen.icons[i](), 2)
			if not (string.sub(iconbmp,1,1) == "*" or string.sub(iconbmp,1,1) == ";") then
				ui.list_wScreenIcons:add({bmp=iconbmp, phase=iconphase, icon=MODEL.screen.icons[i]()})
			end
		end
		ui.list_wScreenIcons:sort("phase")
		ui.list_wScreenIcons:sort("bmp")
	end
	sc_NextStateAnim(st_ManagePOIGroupIcon, "horz_scroll", 1, "")
end

sc_CurrentPoiGroupIconSelected = function()
	if wGroupIcon then
		MODEL.lua.wSettingDistVisual = MODEL["*"].icon()
	else
		MODEL.my.poi.current.icon = MODEL["*"].icon()
	end
	sc_back()
end

-- poi edit

sc_wShowNewMessageBox = function(text1,f_button1,text_button1,icon_button1,text2,f_button2)
	local typetext1 = type(text1) == "wstring" and "_wstr" or ""
	local f_cancel = f_button2 ~= "nil" and f_button2 or ""
	MODEL.screen.msgbox.new.setup(2)
	MODEL.screen.msgbox.new["set_line"..typetext1](1, text1)
	if text2 ~= nil then
		local typetext2 = type(text2) == "wstring" and "_wstr" or ""
		MODEL.screen.msgbox.new["set_line"..typetext2](2, text2)
	end
	MODEL.screen.msgbox.new.setup_button(1, f_button1, text_button1, "", icon_button1)
	MODEL.screen.msgbox.new.setup_button(2, f_cancel, m_i18n("Cancel"), "", "ico_cancel_mid.bmp#3")
	MODEL.screen.msgbox.create_new()
end


sc_AddPOI = function(closelocal)
	if closelocal then
		sc_close_local_menu()
	end
	sc_wPOIStructureMainReset(false)
	sc_NextStateAnim(st_AddPOI, "fade", 1, "")
end

createState("st_AddPOI")
st_AddPOI:useLayers(ui_Title, ui_Status, ui_Background, ui_List_Background, uieffect, ui_AddPOI)
st_AddPOI.enter = function()
	EPoiScrollPos = {}
end

st_AddPOI.init = function()
	sc_wSetTitle_AP()
end

sc_Structure_ToChildAP = function()
	table.insert(EPoiScrollPos, MODEL.ui.lst_AP.scroll_pos())
	local structure = MODEL.poi.structure
	structure.group_list.index = index
	structure.to_child()
	structure.execute()
	MODEL.ui.lst_AP.scroll_pos = 0
	sc_wSetTitle_AP()
end

sc_Structure_ToParentAP = function()
	local structure = MODEL.poi.structure
	local LastScrollPos = EPoiScrollPos[table.maxn(EPoiScrollPos)]
	table.remove(EPoiScrollPos)
	structure.to_parent()
	structure.execute()
	sc_wSetTitle_AP()
	doDelayed(1, function() MODEL.ui.lst_AP.scroll_pos = LastScrollPos end)
end

sc_wSetTitle_AP = function()
	local title = translate(m_i18n("Add POI")) .. (MODEL.poi.structure.parent_name() and L" - " or L"") .. MODEL.poi.structure.parent_name()
	local titlealt = translate(m_i18n("Select group")) .. (MODEL.poi.structure.parent_name() and L" - " or L"") .. MODEL.poi.structure.path_text()
	txtTitle.TEXT = vActiveState() == "st_addpoi" and title or titlealt
end

sc_CreateNewGroupMainAP = function()
	MODEL.regional.keyboard.smartkey_model("")
	inpSI_Text.VALUE = L""
	inpSI_Text.EMPTYTITLE	= m_i18n("<Enter new POI group name>")
	MODEL.lua.easyShowDoneKey = true
	ui.vKeyTableDone = sc_CreateNewGroupDoneAP
	inputFieldRequired = true
	txtTitle.TEXT = m_i18n("Create POI Group")
	sc_NextStateAnim(st_SimpleInputText, "fade", 1, "")
	MODEL.regional.keyboard.load_panel_by_name(L"QWERTY")
end
 
sc_CreateNewGroupDoneAP = function()
	name = ui.inpSI_Text.VALUE()
	if name == L"" then
		name = L"<New Group>"
	end
	name = "@"..tostring(name)
	name = m_i18n(name)
	MODEL.my.poi.add_group(MODEL.poi.structure.search_root(), MODEL.poi.find_provider("userpoi"), name)
 	MODEL.poi.structure.execute()
	PREVSTATE()
end
 
sc_AddPOIToGroupMain = function()
	MODEL.regional.keyboard.smartkey_model("")
	inpSI_Text.VALUE = L""
	inpSI_Text.EMPTYTITLE = m_i18n("<Enter new POI name>")
	MODEL.lua.easyShowDoneKey = true
	ui.vKeyTableDone = sc_SetNewPOIName
	inputFieldRequired = true
	txtTitle.TEXT = m_i18n("Create POI")
	sc_NextStateAnim(st_SimpleInputText, "fade", 1, "")
end

sc_SetNewPOIName = function()
	local name = ui.inpSI_Text.VALUE()
	if name == L"" then
		name = L"<New POI>"
	end
	MODEL.my.poi.add_poi_selected(MODEL.poi.structure.search_root(), MODEL.poi.find_provider("userpoi"))
	MODEL.my.poi.current.name = name
	MODEL.my.poi.select_poi(MODEL.my.poi.current.provider_id(), MODEL.my.poi.current.id())
	sc_SelectSavedFavorites()
	PREVSTATE()
	PREVSTATE()
	NEXTSTATE(st_ShowPOIInfo)
end

sc_ModifyPOINameMain = function()
	sc_close_local_menu()
	MODEL.regional.keyboard.smartkey_model("")
	inpSI_Text.VALUE = MODEL.my.poi.current.name()
	inpSI_Text.EMPTYTITLE = m_i18n("<Enter new POI name>")
	MODEL.lua.easyShowDoneKey = true
	ui.vKeyTableDone = sc_ModifyPOIName
	inputFieldRequired = true
	txtTitle.TEXT = m_i18n("New POI name")
	sc_NextStateAnim(st_SimpleInputText, "fade", 1, "")
end

sc_ModifyPOIName = function()
	local name = ui.inpSI_Text.VALUE()
	if name == L"" then
		name = L"<New POI>"
	end
	MODEL.my.poi.current.name = name
	MODEL.my.poi.select_poi(MODEL.my.poi.current.provider_id(), MODEL.my.poi.current.id())
	PREVSTATE()
end
sc_ModifyPOIInfoMain = function()
	sc_close_local_menu()
	MODEL.regional.keyboard.smartkey_model("")
	inpSI_Text:MAXLENGTH(100)
	inpSI_Text.VALUE = MODEL.my.poi.current.address.ext()
	inpSI_Text.EMPTYTITLE = m_i18n("<Enter new POI Info>")
	MODEL.lua.easyShowDoneKey = true
	ui.vKeyTableDone = sc_ModifyPOIInfoDone
	inputFieldRequired = false
	txtTitle.TEXT = m_i18n("New POI Info")
	sc_NextStateAnim(st_SimpleInputText, "fade", 1, "")
end

sc_ModifyPOIInfoDone = function()
	MODEL.my.poi.current.address.ext = ui.inpSI_Text.VALUE()
	PREVSTATE()
end

sc_wLMDeletePOI = function(closelocal)
	if closelocal then
		sc_close_local_menu()
	end
	sc_wShowNewMessageBox(m_i18n("Are you sure you want to delete this POI?"),"sc_wLMDeletePOI_OK", m_i18n("Delete"),"ico_del_sml.bmp#3",MODEL.my.map.selected_item.name())
end
 
sc_wLMDeletePOI_OK = function()
	MODEL.my.poi.current.remove()
	MODEL.poi.resultpoi.clear()
	MODEL.my.map.select_address(MODEL.map.cursor.position())
	sc_ResetStrappedCursor()
	if vActiveState() == "st_easynav" then
		sc_start_ExitDragMode()
	end
end

sc_wLMDeletePOIfromInfo = function()
	sc_close_local_menu()
	sc_wShowNewMessageBox(m_i18n("Are you sure you want to delete this POI?"),"sc_wLMDeletePOIfromInfo_OK", m_i18n("Delete"),"ico_del_sml.bmp#3",MODEL.my.poi.current.name())
end
 
sc_wLMDeletePOIfromInfo_OK = function()
	PREVSTATE()
	MODEL.my.poi.current.remove()
	if vActiveState() == "st_poiselectiononmapresult" then
		PREVSTATE()
	end
	if vActiveState() == "st_easynav" then
		MODEL.poi.resultpoi.clear()
		MODEL.my.map.select_address(MODEL.map.cursor.position())
		sc_start_ExitDragMode()
		sc_ResetStrappedCursor()
	end
end

sc_wRenamePoiGroup = function()
	MODEL.regional.keyboard.smartkey_model("")
	inpSI_Text.VALUE = L""
	inpSI_Text.EMPTYTITLE = m_i18n("<Enter new POI group name>")
	MODEL.lua.easyShowDoneKey = true
	ui.vKeyTableDone = sc_wRenamePoiGroupDone
	inputFieldRequired = true
	txtTitle.TEXT = m_i18n("Rename POI Group")
	NEXTSTATE(st_SimpleInputText)
	MODEL.regional.keyboard.load_panel_by_name(L"QWERTY")
end
 
sc_wRenamePoiGroupDone = function()
	name = ui.inpSI_Text.VALUE()
	if name == L"" then
		name = L"<New Group>"
	end
	MODEL.lua.wSettingDistSoundName = name
	PREVSTATE()
end
 
sc_DeletePoiGroup = function()
	sc_wShowNewMessageBox(m_i18n("Are you sure you want to delete Group and all POIs in this Group?"),"sc_DeletePoiGroupDone", m_i18n("Delete"),"ico_DeleteAll_mid.bmp#3")
end

sc_DeletePoiGroupDone = function()
	MODEL.my.poi.delete_content(wCurrentGroup, MODEL.poi.find_provider("userpoi"))
	MODEL.my.poi.delete_group(wCurrentGroup, MODEL.poi.find_provider("userpoi"))
	MODEL.poi.structure.execute()
	PREVSTATE()
end

sc_wPOIStructureMainReset = function(pictures)
	sc_ForcePoiInit()
	MODEL.poi.structure.reset()
	MODEL.poi.structure.clear_providers()
	MODEL.poi.structure.add_provider(MODEL.poi.find_provider("ropoi"))
	MODEL.poi.structure.add_provider(MODEL.poi.find_provider("kmlpoi"))
	MODEL.poi.structure.add_provider(MODEL.poi.find_provider("userpoi"))
	if pictures then
		MODEL.poi.structure.add_provider(MODEL.poi.find_provider("picturepoi"))
	end
	MODEL.poi.structure.sort = "name"
	MODEL.poi.structure.execute()
end


sc_SetFavoritesVisibility = function()
end

-- tripcomp --------------------------------------------------

sc_wGetTripComputerName = function(i)
	return (i==0 and m_i18n("TRACK_TIME~Current Route") or (i==1 and m_i18n("TRACK_TIME~Statistics") or translated_format(m_i18n("TRACK_TIME~User Trip %s"), towstring(i-1))))
end
 
sc_wTripComputer_OnRelease = function()
	sc_NextStateAnim(st_wTripComputer, "fade", 1, "")
end
 
createState("st_wTripComputer")
st_wTripComputer:useLayers(ui_wTripComputer, backgroundLayers, uieffect)
st_wTripComputer.init = function()
	txtTitle:SET(m_i18n("Trip Computer"))
end
 
sc_wTripComputerPause = function()
	MODEL.other.trips[index].pause()
end
 
sc_wTripComputerReset = function()
	MODEL.screen.msgbox.new.setup(2)
	MODEL.screen.msgbox.new.set_line(1, m_i18n("This will reset this trip."))
	MODEL.screen.msgbox.new.setup_button(1, "sc_wTripComputerResetOK", m_i18n("Trip~Reset"), L"", "ico_done_mid.bmp#3")
	MODEL.screen.msgbox.new.setup_button(2, "", m_i18n("Cancel"), L"", "ico_cancel_mid.bmp#3")
	MODEL.screen.msgbox.create_new()
end
 
sc_wTripComputerResetOK = function()
	MODEL.other.trips[MODEL.other.trips.index()].reset()
end 

sc_gj_reset_trc = function()
	MODEL.other.trips[0].reset()
end

sc_gj_tripcompreset = function()
	MODEL.screen.msgbox.new.setup(2)
	MODEL.screen.msgbox.new.set_line(1, m_i18n("Are you sure you want to reset trip computer?"))
	MODEL.screen.msgbox.new.setup_button(1, "sc_gj_reset_trc", m_i18n("Reset"), L"", "ico_done_mid.bmp#3")
	MODEL.screen.msgbox.new.setup_button(2, "sc_CancelExit", m_i18n("Cancel"), L"", "ico_cancel_mid.bmp#3")
	MODEL.screen.msgbox.create_new()
end 

-- gj tripcomp --------------------------------------------------

sc_gjTripLoad = function()
  local tmtmp = TIMESPAN.new(0)
  if MODEL.ui.gjUserTCList.size() > 0 then
	for i = 0, (MODEL.ui.gjUserTCList.size()-1) do
		MODEL.other.trips[i].reset()		
		MODEL.other.trips[i].speed_total_avg = tonumber(MODEL.ui.gjUserTCList[i].ls_total_avg())
		MODEL.other.trips[i].speed_driving_avg = tonumber(MODEL.ui.gjUserTCList[i].ls_driving_avg())
		MODEL.other.trips[i].speed_max = tonumber(MODEL.ui.gjUserTCList[i].ls_max())
		MODEL.other.trips[i].distance_total = tonumber(MODEL.ui.gjUserTCList[i].ld_total())
		MODEL.other.trips[i].distance_urban = tonumber(MODEL.ui.gjUserTCList[i].ld_urban())
		MODEL.other.trips[i].distance_rural = tonumber(MODEL.ui.gjUserTCList[i].ld_rural())	
		MODEL.other.trips[i].min_elevation = tonumber(MODEL.ui.gjUserTCList[i].le_min())
		MODEL.other.trips[i].max_elevation = tonumber(MODEL.ui.gjUserTCList[i].le_max())	
		tmtmp = tonumber(MODEL.ui.gjUserTCList[i].lt_total())
		MODEL.other.trips[i].time_total = MODEL.other.trips[i].time_total() + tmtmp
		tmtmp = tonumber(MODEL.ui.gjUserTCList[i].lt_driving())
		MODEL.other.trips[i].time_driving = MODEL.other.trips[i].time_driving() + tmtmp
		tmtmp = tonumber(MODEL.ui.gjUserTCList[i].lt_stopped())
		MODEL.other.trips[i].time_stopped = MODEL.other.trips[i].time_stopped() + tmtmp
	end
  end
end

sc_gjTripSave = function() 
  MODEL.ui.gjUserTCList.clear()
  MODEL.lua.vgjNum_of_trips = MODEL.lua.vgjNum_of_trips()-1 
  for i = 0, MODEL.lua.vgjNum_of_trips() do
	local vst_date = MODEL.other.trips[i].start_time.date()
	local vst_time = MODEL.other.trips[i].start_time.time()	
	local vs_total_avg = MODEL.other.trips[i].speed_total_avg()
	local vs_driving_avg = MODEL.other.trips[i].speed_driving_avg()
	local vs_max = MODEL.other.trips[i].speed_max()
	local vt_total = MODEL.other.trips[i].time_total()
	local vt_driving = MODEL.other.trips[i].time_driving()
	local vt_stopped = MODEL.other.trips[i].time_stopped()
	local vd_total = MODEL.other.trips[i].distance_total()
	local vd_urban = MODEL.other.trips[i].distance_urban()
	local vd_rural = MODEL.other.trips[i].distance_rural()
	local ve_min = MODEL.other.trips[i].min_elevation()
	local ve_max = MODEL.other.trips[i].max_elevation()
	local vf_consumption = MODEL.other.trips[i].fuel_consumption()	
	ui.gjUserTCList:add({lst_date=vst_date, lst_time=vst_time, ls_total_avg=vs_total_avg, ls_driving_avg=vs_driving_avg, ls_max=vs_max, lt_total=vt_total, lt_driving=vt_driving, lt_stopped=vt_stopped, ld_total=vd_total, ld_urban=vd_urban, ld_rural=vd_rural, le_min=ve_min, le_max=ve_max, lf_consumption=vf_consumption })
	MODEL.ui.gjUserTCList.save()	
  end   
end


ExitState.init_orig = ExitState.init
ExitState.init = function()
  if MODEL.lua.vgjTripCompDataSave() then
	sc_gjTripSave()
  end  
  doDelayed(50, EXIT)
end

RestartState.init_orig = RestartState.init
RestartState.init = function()
  if MODEL.lua.vgjTripCompDataSave() then
	sc_gjTripSave()
  end  
  doDelayed(50, FORCE_RENDER_SCREEN())
end

---- gj poi search area ----------------------------------------

sc_OtherPoi_SetupSearch_orig = sc_OtherPoi_SetupSearch
sc_OtherPoi_SetupSearch = function()
  local struct_search = MODEL.poi.struct_search()
  struct_search.reset()
  struct_search.distance_on_route = "disabled"
  struct_search.calculate_detour = "disabled"
  struct_search.area = MODEL.lua.vgjPoiFindDist()
  struct_search.sort = "multi_sort:igo9_specialpoi_first+distance"
  if selectedSearchCenter == ESearchCenter.in_a_city then
    struct_search.center = "fixed"
    struct_search.position = MODEL.map.cursor.position()
  elseif selectedSearchCenter == ESearchCenter.around_gps then
    struct_search.center = "gps"
  elseif selectedSearchCenter == ESearchCenter.around_destination then
    struct_search.center = "destination"
  elseif selectedSearchCenter == ESearchCenter.around_route then
    struct_search.center = "route"
    struct_search.distance_on_route = "enabled"
    struct_search.calculate_detour = "enabled"
    struct_search.area = 150000
    struct_search.sort = "multi_sort:igo9_specialpoi_first+detour_group"
  end
end

sc_gj_StructSearch = function(dist)
	sc_close_local_menu()
	local value = double(dist)
	MODEL.lua.vgjPoiFindDist = value:toInt()
	sc_back_to_cockpit()	
	sc_FindOtherPoi_AroundGps()
	sc_gjShowHelpText(m_i18n((MODEL.lua.vgjPoiFindDist()/1000).." km"), "ico_done_sml.bmp#3")
end

---- gj turn restriction ----------------------------------------
sc_gj_restrictsound = function(fromstart)
	if ((MODEL.lua.vgjShowRestTurn() == 1 and not MODEL.navigation.has_route()) or MODEL.lua.vgjShowRestTurn() == 2) then
		if MODEL.lua.vgjSoundRestTurn() then
			PLAYSOUND("alarmeffect", "turnrestriction")
		end	
		if MODEL.navigation.turn_restriction_icon.valid() and fromstart then
			obs_gj_turnrest_chg:START("NO_TRIGGER")
		end
	end
end

sc_gj_turnrest_change_start = function()
	gjTurnRestDelayed = doDelayed(1, function() sc_gj_restrictsound(true) end)
end

sc_gj_turnrest_change_stop = function()
	if gjTurnRestDelayed ~= -1 then
		killDelayed(gjTurnRestDelayed)
		gjTurnRestDelayed = -1
	end
	obs_gj_turnrest_chg:STOP()
end

-- gj short menu --------------------------------------------------
sc_OpenMapMenu_orig = sc_OpenMapMenu
sc_OpenMapMenu = function()
	MODEL.lua.vEasyNavMapMenuOpen = not MODEL.lua.vEasyNavMapMenuOpen()
    killDelayed(gjopenmenuevent)
    gjopenmenuevent = doDelayed(250, function()
		MODEL.lua.vEasyNavMapMenuOpen = false
	end
	)
end

sc_wBuildCockpitMenu = function()
	for i = 0, 7 do
		local itemIdx = sc_gjFindItemInCockpitList(PERSISTENT.gj_savedCockpitMenu[i]())
		MODEL.ui.fullCockpitMenuList[itemIdx].is_in_menu = true
		MODEL.ui.fullCockpitMenuList[itemIdx].menu_index = i
	end
end

createState("st_gjCustomizeCockpitMenu")
st_gjCustomizeCockpitMenu:useLayers(backgroundLayers, ui_gjCustomizeCockpitMenu)
sc_MapSettings_BottomMenu = function()
	txtTitle:SET(m_i18n("Select a Shortcut"))
	sc_NextStateAnim(st_gjCustomizeCockpitMenu, "fade", 1, "")
end

createState("st_gjCockpitMenuReplaceList")
st_gjCockpitMenuReplaceList:useLayers(backgroundLayers, ui_gjCockpitMenuReplaceList)
st_gjCockpitMenuReplaceList.init = function()
	txtTitle:SET(m_i18n("Select a Shortcut"))
	ui.fullCockpitMenuList:sort("uniq_id")
end

st_gjCockpitMenuReplaceList.exit = function()
	ui.fullCockpitMenuList:sort("menu_index")
end

sc_gjReplaceSelectedCockpitMenuItem = function(itemId)
	local oldId = PERSISTENT.gj_savedCockpitMenu[vMapMenuButtonAct]()
	local oldItemIdx = sc_gjFindItemInCockpitList(oldId)
	local newItemIdx = sc_gjFindItemInCockpitList(itemId)
	if MODEL.ui.fullCockpitMenuList[newItemIdx].is_in_menu() then
		if itemId == oldId then
			return 
		end
		local newItemIdxForSwap = MODEL.ui.fullCockpitMenuList[newItemIdx].menu_index()
		MODEL.ui.fullCockpitMenuList[oldItemIdx].menu_index = MODEL.ui.fullCockpitMenuList[newItemIdx].menu_index()
		MODEL.ui.fullCockpitMenuList[newItemIdx].menu_index = vMapMenuButtonAct
		PERSISTENT.gj_savedCockpitMenu[vMapMenuButtonAct] = itemId
		PERSISTENT.gj_savedCockpitMenu[newItemIdxForSwap] = oldId
	else
		MODEL.ui.fullCockpitMenuList[oldItemIdx].is_in_menu = false
		MODEL.ui.fullCockpitMenuList[oldItemIdx].menu_index = 100
		MODEL.ui.fullCockpitMenuList[oldItemIdx].cockpitvisible = true
		MODEL.ui.fullCockpitMenuList[newItemIdx].is_in_menu = true
		MODEL.ui.fullCockpitMenuList[newItemIdx].menu_index = vMapMenuButtonAct
		PERSISTENT.gj_savedCockpitMenu[vMapMenuButtonAct] = itemId
	end
end

sc_gjFindItemInCockpitList = function(itemId)
	for i = 0, MODEL.ui.fullCockpitMenuList.size() - 1 do
		if MODEL.ui.fullCockpitMenuList[i].id() == itemId then
			return i
		end
	end
	return -1
end

sc_gjOpenCockpitMenuItem = function(index)	   
	if vActiveState() == "st_easynav" then
		local scriptName = MODEL.ui.fullCockpitMenuList.quick_list[index].onrelease()
		_G[scriptName]()
	else
		vMapMenuButtonAct = index
		sc_NextStateAnim(st_gjCockpitMenuReplaceList, "horz_scroll", 1, "")
	end
end
 
sc_gjOpenLongCockpitMenuItem = function(index)
	local scriptName = MODEL.ui.fullCockpitMenuList.quick_list[index].onlongclick()
	if scriptName == "" then
		sc_gjShowHelpText(MODEL.ui.fullCockpitMenuList.quick_list[index].text())
	else
		_G[scriptName]()
	end
end
 
---------------

sc_Quick_mute = function()
	if MODEL.sound.voice_muted() == true then
		MODEL.sound.voice_muted = false
		MODEL.sound.effect_muted = false
		MODEL.sound.media_muted = false
		MODEL.sound.alert_muted = false
		MODEL.sound.ding_muted = false
--		MODEL.sound.os_muted = false
		sc_gjShowHelpText(m_i18n("Volume"), "ico_done_sml.bmp#3")
	else
		MODEL.sound.voice_muted = true
		MODEL.sound.effect_muted = true
		MODEL.sound.media_muted = true
		MODEL.sound.alert_muted = true
		MODEL.sound.ding_muted = true
--		MODEL.sound.os_muted = true
		sc_gjShowHelpText(m_i18n("Volume"), "ico_cancel_mid.bmp#3")
	end
end

sc_gjdelroute_OnRelease = function()
	if MODEL.route.list.navigated.waypoints.list.size() > 2 then
		sc_DeleteNextWaypoint()
	else
		sc_map_local_menu_deleteroute()
		vDestinationReachedPopoUpID:SET(-1)
	end
	sc_back_to_cockpit()
	doDelayed(10, function()
		sc_back_to_cockpit()
	end
	)	
end

sc_Quick_record_onlongclick = function()
	sc_NextStateAnim(st_tracklog, "fade", 1, "")
end 

sc_DriverProfiles = function()
    sc_NextStateAnim( st_DriverProfiles, "horz_scroll", 1, "" )
end

sc_Show_Calculator = function()
	sc_NextStateAnim(st_Calculator, "fade", 1, "")
end

sc_gjStopTrackLog = function()
	sc_StopTrackLog()
	sc_gjShowHelpText(m_i18n("TRACKLOG~Stop Recording"), "ico_cancel_mid.bmp#3")
end

sc_gjStartTrackLog = function()
	sc_StartTrackLog()
	sc_gjShowHelpText(m_i18n("Track Recording"), "ico_done_sml.bmp#3")
end 

sc_Quick_FindAddress_onlongclick = function()
	sc_NextStateAnim(st_FindAddress, "horz_scroll", 1, "")
end

sc_gjallsettings_OnRelease = function()
	sc_NextStateAnim(st_EasySettingsMenu, "horz_scroll", 1, "")
end

sc_gj_2d3d = function()
  if MODEL.lua.vEasyMapMode() == 2 then
	MODEL.lua.vEasyMapMode = 1 
  else 
    MODEL.lua.vEasyMapMode = 2
  end
  sc_set_Nav2D3D()
end


--RecalcInfo 
gjRI_CalckEvent = 0
sc_gj_recalculate_start = function()
	gjRI_CalckEvent = 1
	MODEL.lua.vgjRecalcInfo_Show = false
end


sc_gj_recalculate_end = function()

	if MODEL.lua.vgjRI_TmpDist() == 0 or MODEL.lua.vgjRI_TmpTime() == 0 then
		MODEL.lua.vgjRI_TmpDist = MODEL.navigation.distance_to_destination()
		MODEL.lua.vgjRI_TmpTime = MODEL.navigation.time_to_destination()
		
--arriving time plan
		MODEL.lua.vgjATP_TmpTime = MODEL.navigation.eta_at_destination()
		MODEL.lua.vgjATP_TmpRMethod = MODEL.lua.routeMethodText()
	else
		if MODEL.lua.vgjATP_TmpRMethod() ~= MODEL.lua.routeMethodText() then
			MODEL.lua.vgjATP_TmpTime = MODEL.navigation.eta_at_destination()
			MODEL.lua.vgjATP_TmpRMethod = MODEL.lua.routeMethodText()
		end

		if (MODEL.lua.vgjRI_TmpDist() ~= MODEL.navigation.distance_to_destination() or MODEL.lua.vgjRI_TmpTime() ~= MODEL.navigation.time_to_destination()) and (MODEL.lua.vgjRecalcInfo_Enable()) then
			MODEL.lua.vgjRI_ShowTmpDist = MODEL.lua.vgjRI_TmpDist()-MODEL.navigation.distance_to_destination()
			MODEL.lua.vgjRI_ShowTmpTime = MODEL.lua.vgjRI_TmpTime()-MODEL.navigation.time_to_destination()

			doDelayed(30, function()
				if MODEL.navigation.distance_to_destination() > 0 then
					MODEL.lua.vgjRI_TmpDist = MODEL.navigation.distance_to_destination()
					MODEL.lua.vgjRI_TmpTime = MODEL.navigation.time_to_destination()
				end
			end
			)
									
			doDelayed(35, function()
				if MODEL.lua.vgjRI_ShowTmpDist() ~= 0 then
					MODEL.lua.vgjRecalcInfo_Show = true
					MODEL.sound.playchanneltest("alarmeffect", L"recalc")
				end	
			end
			)
			
			killDelayed(gjDel1)
			gjDel1 = doDelayed(800, function()
				MODEL.lua.vgjRecalcInfo_Show = false
			end
			)

		end
	end

	killDelayed(gjDel2)
	gjDel2 = doDelayed(60, function()
		gjRI_CalckEvent = 0
	end
	)

 end
    
sc_DeleteRouteKeepStart_orig = sc_DeleteRouteKeepStart
sc_DeleteRouteKeepStart = function(SkipStart)
  local navigated = MODEL.route.list.navigated
  if SkipStart == nil then
    SkipStart = true
  end
  if navigated.waypoints.start_is_user_selected() and SkipStart then
    MODEL.route.waypoints.recalculate_on_modify = false
    while #navigated.waypoints.list > 1 do
      navigated.waypoints.remove(navigated.waypoints.list.lastindex())
    end
    MODEL.route.waypoints.recalculate_on_modify = true
    MODEL.route.clear_navigated_route_state()
  else
    if navigated.waypoints.start_is_user_selected() then
      sc_DeleteStartPoint()
    end
    navigated.clear()
  end
  sc_gj_routenew_end()
end

sc_gj_routenew_end = function()
	MODEL.lua.vgjRI_TmpDist = 0
	MODEL.lua.vgjRI_TmpTime = 0
--arriving time plan
	MODEL.lua.vgjATP_TmpTime = 0
	sc_gj_reset_atp()
end

--gj-ak workaround for occasional route deleting during start
sc_TimeJump = function()
  if MODEL.other.timejump() then
    MODEL.other.timejump = false
    MODEL.screen.msgbox.on_screen.close()
    if MODEL.lua.vMapMenuOpen() then
      sc_CloseMapLocalMenu(true)
    end
    if vLocalMenuEnabled() then
      sc_close_local_menu(true)
    end
    if MODEL.lua.dragMode() then
      sc_backFromdragmode()
    end
    local distanceToDestination = MODEL.navigation.distance_to_destination()
    if not MODEL.navigation.is_in_simulation() then
      if #MODEL.route.list.navigated.waypoints.list > 1 then
          sc_del_route_msg()
      else
        sc_GoTo_MainMenu()
      end
    end
  end
end
-----------------

sc_gj_reset_atp = function()
--arriv time plan
	MODEL.lua.vgjATP_TmpTime = MODEL.navigation.eta_at_destination()
	MODEL.lua.vgjATP_TmpRMethod = MODEL.lua.routeMethodText()
end

sc_gj_atpreset = function()
	MODEL.screen.msgbox.new.setup(2)
	MODEL.screen.msgbox.new.set_line(1, m_i18n("Are you sure you want to reset time?"))
	MODEL.screen.msgbox.new.setup_button(1, "sc_gj_reset_atp", m_i18n("Reset"), L"", "ico_done_mid.bmp#3")
	MODEL.screen.msgbox.new.setup_button(2, "sc_CancelExit", m_i18n("Cancel"), L"", "ico_cancel_mid.bmp#3")
	MODEL.screen.msgbox.create_new()
end

--2DNU overview
wBeforeOverviewStates = {"navmap3d", "2dheadup", "2dnorthup", "simulate", "simulate_2d", "simulate_2d_nu"}
sc_PreSet_2d_woverview = function(mapState)
	mapState.car_posy = 50
	mapState.center_posy = 50
	mapState.rotate_follow = false
	mapState.rotate = 0
end

sc_Set_2d_woverview = function(mapState)
	sc_Set_Navmap_2D_Headup(mapState)
	sc_PreSet_2d_woverview(mapState)
end

sc_wSetNavCarPos_overview = function()
	if type(obs_wcockpitcarposition) == "userdata" then
		obs_wcockpitcarposition:TRIGGER()
	elseif type(sc_SetNavCarPos) == "function" then
		local isPanelOpen = MODEL.lua.HwyPoiListIsVisible() or MODEL.screen.msgbox.is_onscreen()
		sc_SetNavCarPos(isPanelOpen)
	end
end

MODEL.map.create_state("2d_woverview")
sc_Set_2d_woverview(MODEL.map.states["2d_woverview"])
st_EasyNav:useLayers(ui_wAdvancedOverview)
sc_wAdvancedOverviewStart = function()
	doDelayed(5, function()
		local mapLayer = MODEL.map.primary()
		if st_EasyNav.active and mapLayer.center_follow() and mapLayer.camera_settings.overview() then
			mapLayer.save_state(mapLayer.state())
			mapLayer.switch_state("2d_woverview", 1)
			sc_PreSet_2d_woverview(mapLayer)
			doDelayed(1, sc_wSetNavCarPos_overview)
		end
	end)
end

sc_wAdvancedOverviewStop = function()
	if MODEL.map.primary.center_follow() then
		local laststate = MODEL.lua.vEasyMapMode() + (MODEL.navigation.is_in_simulation() and 3 or 0)
		MODEL.map.primary.switch_state(wBeforeOverviewStates[laststate], 1)
		sc_Set_Follow_On()
		doDelayed(1, sc_wSetNavCarPos_overview)
	end
end

-- More Highway

sc_SetRouteTypesTable = function()
	local tmp = false
	if MODEL.lua.green_routing_enabled() then
		if MODEL.lua.vehicleIsGreen() then
			for cntr = 1, #RouteTypes do
				if RouteTypes[cntr].name == "Economical" then
					table.remove(RouteTypes, cntr)
					break
				end
			end
		else
			for cntr = 1, #RouteTypes do
				if RouteTypes[cntr].name == "Economical" then
					tmp = true
					break
				end
			end
			if not tmp then
				table.insert(RouteTypes, 2, {name = "Economical", setting = L"ECO"})
			end
		end
		if MODEL.lua.showGreenUI() then
			tmp = false
			for cntr = 1, #RouteTypes do
				if RouteTypes[cntr].name == "Green" then
					tmp = true
					break
				end
			end
			if not tmp then
				table.insert(RouteTypes, 2, {name = "Green", setting = L"GREEN"})
			end
		else
			for cntr = 1, #RouteTypes do
				if RouteTypes[cntr].name == "Green" then
					table.remove(RouteTypes, cntr)
					break
				end
			end
		end
	end
	sc_SetRouteTypesTableFreeways()
end
 
sc_SetRouteTypesTableFreeways = function()
	local tmp = false
	for cntr = 1, #RouteTypes do
		if RouteTypes[cntr].setting == L"ECO" then
			tmp = true
			table.remove(RouteTypes, cntr)
			break
		end
	end
	if tmp then
		table.insert(RouteTypes, 2, {name = "Economical", setting = L"ECO"})
	end
	tmp = false
	for cntr = 1, #RouteTypes do
		if RouteTypes[cntr].setting == L"MOST_FREEWAYS" then
			tmp = true
			break
		end
	end
	if not tmp then
		table.insert(RouteTypes, 5, {name = "More highways", setting = L"MOST_FREEWAYS"})
	end
	sc_SetCalcmethodText()
end
 
-- Draw all route

sc_DrawComparedRoute_orig = sc_DrawComparedRoute
sc_DrawComparedRoute = function(routeNumber)
	MODEL.sound.voice_muted = true
	local sumTopLeft = GCOOR.new()
	local sumBottomRight = GCOOR.new()
	local routemodel = "nonexistent"
	for i = 1, #MODEL.ui.lm_comparedRoutes do
		if i == routeNumber or MODEL.ui.lm_comparedRoutes[i - 1].route_locked() then
			routemodel = routemodel .. ",compare" .. i
			local top_left = GCOOR.new()
			local bottom_right = GCOOR.new()
			if MODEL.ui.lm_comparedRoutes[i - 1].top_left():IsValid() then
				top_left = MODEL.ui.lm_comparedRoutes[i - 1].top_left()
				bottom_right = MODEL.ui.lm_comparedRoutes[i - 1].bottom_right()
			else
				local TL, BR, ok = MODEL.route.list["compare" .. i].get_bounding_box()
				if ok then
					MODEL.ui.lm_comparedRoutes[i - 1].top_left = TL
					MODEL.ui.lm_comparedRoutes[i - 1].bottom_right = BR
					top_left = TL
					bottom_right = BR
				end
			end
			if top_left:IsValid() and bottom_right:IsValid() then
				sumTopLeftCompare, sumBottomRightCompare = sc_AddGCPointToBoundaries(top_left, sumTopLeftCompare, sumBottomRightCompare)
				sumTopLeftCompare, sumBottomRightCompare = sc_AddGCPointToBoundaries(bottom_right, sumTopLeftCompare, sumBottomRightCompare)
			end
		else
			routemodel = routemodel .. ",nonexistent"
		end
	end
	sc_FitComparedRoutes(sumTopLeftCompare, sumBottomRightCompare)
	MODEL.map.primary.route_model = routemodel
	txtCompareRoutesLabel.TEXT = MODEL.ui.lm_comparedRoutes[routeNumber - 1].name()
end
 
st_CompareRoutes.mode_landscape = function()
	sc_reset_primary(false)
	doDelayed(1, function() sc_FitComparedRoutes(sumTopLeftCompare, sumBottomRightCompare) end)
end
 
st_CompareRoutes.mode_portrait = function()
	sc_reset_primary(false)
	doDelayed(1, function() sc_FitComparedRoutes(sumTopLeftCompare, sumBottomRightCompare) end)
end
 
st_CompareRoutes.done = function()
	sumTopLeftCompare = GCOOR.new()
	sumBottomRightCompare = GCOOR.new()
end

sc_FitComparedRoutes = function(topLeft, bottomRight)
	sc_fit_general(topLeft, bottomRight, ui.fitbox_compareroutes.X, ui.fitbox_compareroutes.Y, ui.fitbox_compareroutes.W, ui.fitbox_compareroutes.H)
end 

st_EasyRouteMethod:useLayers("ui_RecalcMsgBox")
st_EasyRouteMethod.init = function()
	sc_CheckOffroadParams()
	ASSERT(not MODEL.route.list.navigated.off_road(), "Should not try to create alternatives for off-road route.")
	if MODEL.lua.wFindAlternativesOriginal() or MODEL.route.vehicle_type() == EVehicleType.Pedestrian or MODEL.route.vehicle_type() == EVehicleType.Bicycle then
		sc_EasyRouteMethodEnter()
	else
		sc_wEasyRouteMethodEnterUser()
	end
	gVoiceMutedSave = MODEL.sound.voice_muted()
	local primary = MODEL.map.primary
	if primary.state() ~= "simulate_2d_nu" and primary.state() ~= "simulate_2d" and primary.state() ~= "simulate" then
		primary.save_state(primary.state())
	end
	primary.enter_state("routemap")
	sc_SetOrientation()
	MODEL.lua.routeMethodScreen = true
	st_EasyRouteMethod.pedestrianWarnIgnored = pedestrianWarnIgnored
	pedestrianWarnIgnored = true
	MainMenuMode_tmp = MODEL.lua.mainMenuMode()
	MODEL.lua.mainMenuMode = false
	if not (MODEL.lua.wFindAlternativesOriginal() or MODEL.route.vehicle_type() == EVehicleType.Pedestrian or MODEL.route.vehicle_type() == EVehicleType.Bicycle) then
		sc_wRefreshShowedRouteModel()
		gTmpSpeedcam = MODEL.warning.speedcam_warning()
		MODEL.warning.speedcam_warning = false
	end
	if MODEL.route.list.navigated.calculation_finished() then
		sc_wEasyRouteMethod_GoStart()
	else
		obs_route_calculated:ONSELECT(sc_wEasyRouteMethod_GoStart)
		obs_route_calculated:START("NO_TRIGGER")
	end
end
 
st_EasyRouteMethod.done = function()
    obs_walternative_calculated:STOP()
    MODEL.map.primary.route_model = ""
	if st_EasyRouteMethod.calcTimerId ~= nil then
		killDelayed(st_EasyRouteMethod.calcTimerId)
		st_EasyRouteMethod.calcTimerId = nil
	end
	MODEL.map.primary.exit_state()
	obs_route_calculated:STOP()
	MODEL.lua.mainMenuMode = MainMenuMode_tmp
	pedestrianWarnIgnored = st_EasyRouteMethod.pedestrianWarnIgnored
	MODEL.lua.routeMethodScreen = false
	vRouteCalcFinishedCallback:CLEAR()
	MODEL.sound.voice_muted = gVoiceMutedSave
	if MODEL.lua.wFindAlternativesOriginal() or MODEL.route.vehicle_type() == EVehicleType.Pedestrian or MODEL.route.vehicle_type() == EVehicleType.Bicycle then
		sc_EasyRouteMethodExit()
	else
		MODEL.warning.speedcam_warning = gTmpSpeedcam
		sc_wEasyRouteMethodExitUser()
	end
end
 
sc_wEasyRouteMethodEnterUser = function()
	MODEL.navigation.autoreplan = false
	AlternativeType = 0
	RouteCount = 5
	for i = 1, RouteCount do
		MODEL.route.create_route_model("multiplan"..i)
	end
end
 
sc_wEasyRouteMethodExitUser = function()
	local selectedIdx = MODEL.lua.alternativeModes()
	local name = "multiplan"..selectedIdx
	if MODEL.route.list["multiplan_current"].valid() then
		MODEL.route.list["multiplan_current"].delete()
	end
	if MODEL.route.list[name].valid() then
		for i = 1, RouteCount do
			if i ~= selectedIdx then
				MODEL.route.list["multiplan"..i].delete()
			end
		end
		MODEL.route.list.navigated.migrate_from(name)
		MODEL.route.list.navigated.settings.check_consistency_with_global_settings()
		sc_CheckOffroadParams()
		MODEL.route.list.navigated.calculation_priority = 10
		MODEL.route.list[name].delete()
	end
	MODEL.route.destroy_route_model("multiplan_current")
	for i = 1, RouteCount do
		MODEL.route.destroy_route_model("multiplan"..i)
	end
	MODEL.ui.lm_RouteMethodUser.clear()
	MODEL.navigation.autoreplan = true
	sc_RecalcGreen()
end
 
sc_wEasyRouteMethod_GoStart = function()
	if MODEL.lua.wFindAlternativesOriginal() or MODEL.route.vehicle_type() == EVehicleType.Pedestrian or MODEL.route.vehicle_type() == EVehicleType.Bicycle then
		sc_EasyRouteMethod_StartAlternatives()
	else
		sc_wEasyRouteMethod_StartAlternativesUser()
	end
end
 
sc_wEasyRouteMethod_StartAlternativesUser = function()
	MODEL.lua.alternativeModes = 0
	MODEL.route.create_route_model("multiplan_current")
	local navigatedRouteModel = MODEL.route.list.navigated
	local targetRouteModel = MODEL.route.list.multiplan_current
	local startFromGps = (not navigatedRouteModel.waypoints.list.isempty() and not navigatedRouteModel.waypoints.start_is_user_selected() and navigatedRouteModel.waypoints.list[0].type() == "start")
	targetRouteModel.copy_from("navigated")
	if startFromGps and not targetRouteModel.move_start_to_gps() then
		targetRouteModel.waypoints.set_start(true)
	end
	AlternativeType = 1
	CalculatedRoute = 0
	MODEL.ui.lm_RouteMethodUser.clear()
	if MODEL.route.list.multiplan_current.calculation_finished() then
		sc_wEasyRouteMethod_CalcFinishedUser()
	else
		obs_walternative_calculated:BOOLMODEL("route.list.multiplan_current.calculation_finished")
		obs_walternative_calculated:ONSELECT(sc_wEasyRouteMethod_CalcFinishedUser)
		obs_walternative_calculated:START("NO_TRIGGER")
	end
end
 
sc_wEasyRouteMethod_CalcFinishedUser = function()
	sc_wRefreshShowedRouteModel()
	obs_walternative_calculated:STOP()
	sc_wEasyRouteMethod_FitUser()
	sc_wEasyRouteMethod_CalculateNextAlternativeUser()
end
 
sc_wEasyRouteMethod_CalculateNextAlternativeUser = function()
	if AlternativeType > #RouteTypes and CalculatedRoute < RouteCount then
		MODEL.ui.lm_RouteMethodUser.resize(CalculatedRoute)
		return
	end 
	CalculatedRoute = CalculatedRoute+1
	if CalculatedRoute > RouteCount then
		RouteCount = RouteCount+1
		MODEL.route.create_route_model("multiplan"..CalculatedRoute)
	end
	local routeModel = MODEL.route.list["multiplan"..CalculatedRoute]
	routeModel.delete()
	local route_name
	if AlternativeType <= #RouteTypes then
		if RouteTypes[AlternativeType].setting == MODEL.route.route_type() then
			routeModel.copy_from("multiplan_current")
		else
			routeModel.copy_waypoints_from("multiplan_current", false)
			routeModel.settings.route_type = RouteTypes[AlternativeType].setting
			routeModel.recalculate()
		end
		AlternativeType = AlternativeType + 1
		route_name = translate(RouteTypes[AlternativeType - 1].name)
		if MODEL.ui.lm_RouteMethodUser.lastindex() + 1 == CalculatedRoute then
			lm_RouteMethodUser[MODEL.ui.lm_RouteMethodUser.lastindex()].text = route_name
			lm_RouteMethodUser[MODEL.ui.lm_RouteMethodUser.lastindex()].showed = true
		else
			ui.lm_RouteMethodUser:add({text = route_name, showed = true})
		end
		sc_wRefreshShowedRouteModel()
		if routeModel.calculation_finished() then
			sc_wEasyRouteMethod_CalcFinishedUser()
		else
			obs_walternative_calculated:BOOLMODEL("route.list.multiplan" .. CalculatedRoute .. ".calculation_finished")
			obs_walternative_calculated:ONSELECT(sc_wEasyRouteMethod_CalcFinishedUser)
			obs_walternative_calculated:START("NO_TRIGGER")
		end
	end
end
 
sc_wEasyRouteMethod_DrawSelectedAlternativeUser = function()
	MODEL.sound.voice_muted = true
	sc_wRefreshShowedRouteModel()
	if not MODEL.lua.map.FitEnabled() then
		sc_wEasyRouteMethod_FitUser()
	end
end
 
sc_wOnOffShowedRoutes = function()
	MODEL["*"].showed = not MODEL["*"].showed()
	sc_wRefreshShowedRouteModel()
end
 
sc_wOnOffShowedRoutes_longclick = function()
	for item in ModelList_iter(MODEL.ui.lm_RouteMethodUser) do
		item.showed = true
	end
	sc_wRefreshShowedRouteModel()
end
 
sc_wRefreshShowedRouteModel = function()
	MODEL.map.primary.route_model = sc_wGetShowedRouteModel(MODEL.lua.alternativeModes())
end
 
sc_wGetShowedRouteModel = function(selected)
	local t = MODEL.ui.lm_RouteMethodUser
	local out = "nonexistent"
	if #t == 0 then
		return out
	end
	for item,index in ModelList_iter(t) do
		out = out .. ((selected == 0 and item.showed() or (index + 1) == selected) and ",multiplan" or ",PL") .. (index + 1)
	end
	return out
end
 
sc_wEasyRouteMethod_FitUser = function()
	local gcTL, gcBR, succ
	local sumTopLeft = GCOOR.new()
	local sumBottomRight = GCOOR.new()
	for item,index in ModelList_iter(MODEL.ui.lm_RouteMethodUser) do
		if MODEL.route.list["multiplan"..(index+1)].valid() then
			gcTL, gcBR, succ = MODEL.route.list["multiplan"..(index+1)].get_bounding_box()
			if succ then
				sumTopLeft, sumBottomRight = sc_AddGCPointToBoundaries(gcTL, sumTopLeft, sumBottomRight)
				sumTopLeft, sumBottomRight = sc_AddGCPointToBoundaries(gcBR, sumTopLeft, sumBottomRight)
			end
		end
	end
	if sumTopLeft:IsValid() and sumBottomRight:IsValid() then
		sc_routemenu_info_fit_open_from_main(sumTopLeft, sumBottomRight)
	else
		gcTL, gcBR, succ = MODEL.route.list["multiplan_current"].get_bounding_box()
		if succ then
			sc_routemenu_info_fit_open_from_main(gcTL, gcBR)
		end
	end
end

-- junction
sc_place_jv_orig = sc_place_jv
sc_place_jv = function()
	if MODEL.lua.vgjMiniJunction() then
		return
	end

  if MODEL.screen.current_orientation_mode() == OrientationMode.Landscape then
    ui.sprJunctionView.LEFT = MODEL.screen.width() / 2 - ui.sprJunctionView.W / 2
    if MODEL.navigation.junctionview_type() == 0 then
      ui.sprJunctionView.TOP = 0
    else
      ui.sprJunctionView.TOP = MODEL.screen.height() - ui.sprJunctionView.H
    end
    ui.sprJunctionViewPatch.VISIBLE = false
  elseif MODEL.navigation.junctionview_type() == 0 then
    ui.sprJunctionView.LEFT = 0
    ui.sprJunctionView.TOP = 0
  else
    local jvTop = MODEL.screen.height() - ui.lst_cockpit.H - ui.sprJunctionView.H
    ui.sprJunctionView.LEFT = MODEL.screen.width() / 2 - ui.sprJunctionView.W / 2
    ui.sprJunctionView.TOP = jvTop
    ui.sprJunctionViewPatch.H = jvTop + gJVPatch_Offset
    ui.sprJunctionViewPatch.VISIBLE = true
  end
  
end

